searchNodes=[{"doc":"Guardian provides a singular interface for authentication in Elixir applications that is token based.Tokens should be:tamper proofinclude a payload (claims)JWT tokens (the default) fit this description.When using Guardian, you'll need an implementation module.defmodule MyApp.Guardian do use Guardian, otp_app: :my_app def subject_for_token(resource, _claims), do: {:ok, to_string(resource.id)} def resource_from_claims(claims) do find_me_a_resource(claims[&quot;sub&quot;]) # {:ok, resource} or {:error, reason} end endThis module is what you will use to interact with tokens in your application.When you use Guardian, the :otp_app option is required. Any other option provided will be merged with the configuration in the config files.The Guardian module contains some generated functions and some callbacks.Generated functionsdefault_token_type()Overridable.Provides the default token type for the token - &quot;access&quot;Token types allow a developer to mark a token as having a particular purpose. Different types of tokens can then be used specifically in your app.Types may include (but are not limited to):&quot;access&quot;&quot;refresh&quot;Access tokens should be short lived and are used to access resources on your API. Refresh tokens should be longer lived and whose only purpose is to exchange for a shorter lived access token.To specify the type of token, use the :token_type option in the encode_and_sign function.Token type is encoded into the token in the &quot;typ&quot; field.Return - a string.peek(token)Inspect a tokens payload. Note that this function does no verification.Return - a map including the :claims key.config(), config(key, default \\\\ nil)Without argument config will return the full configuration Keyword list.When given a key and optionally a default, config will fetch a resolved value contained in the key.See Guardian.Config.resolve_value/1encode_and_sign(resource, claims \\\\ %{}, opts \\\\ [])Creates a signed token.Arguments:resource - The resource to represent in the token (i.e. the user)claims - Any custom claims that you want to use in your tokenopts - Options for the token module and callbacksFor more information on options see the documentation for your token module.# Provide a token using the defaults including the default_token_type {:ok, token, full_claims} = MyApp.Guardian.encode_and_sign(user) # Provide a token including custom claims {:ok, token, full_claims} = MyApp.Guardian.encode_and_sign(user, %{some: &quot;claim&quot;}) # Provide a token including custom claims and a different token type/ttl {:ok, token, full_claims} = MyApp.Guardian.encode_and_sign(user, %{some: &quot;claim&quot;}, token_type: &quot;refresh&quot;, ttl: {4, :weeks})The encode_and_sign function calls a number of callbacks on your implementation module. See Guardian.encode_and_sign/4decode_and_verify(token, claims_to_check \\\\ %{}, opts \\\\ [])Decodes a token and verifies the claims are valid.Arguments:token - The token to decodeclaims_to_check - A map of the literal claims that should be matched. If any of the claims do not literally match verification fails.opts - The options to pass to the token module and callbacksCallbacks:decode_and_verify calls a number of callbacks on your implementation module, See Guardian.decode_and_verify/4# Decode and verify using the defaults {:ok, claims} = MyApp.Guardian.decode_and_verify(token) # Decode and verify with literal claims check. # If the claims in the token do not match those given verification will fail {:ok, claims} = MyApp.Guardian.decode_and_verify(token, %{match: &quot;claim&quot;}) # Decode and verify with literal claims check and options. # Options are passed to your token module and callbacks {:ok, claims} = MyApp.Guardian.decode_and_verify(token, %{match: &quot;claim&quot;}, some: &quot;secret&quot;)revoke(token, opts \\\\ [])Revoke a token.Note: this is entirely dependent on your token module and implementation callbacks.{:ok, claims} = MyApp.Guardian.revoke(token, some: &quot;option&quot;)refresh(token, opts \\ [])Refreshes the time on a token. This is used to re-issue a token with essentially the same claims but with a different expiry.Tokens are verified before performing the refresh to ensure only valid tokens may be refreshed.Arguments:token - The old token to refreshopts - Options to pass to the Implementation Module and callbacksOptions::ttl - The new ttl. If not specified the default will be used.{:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Guardian.refresh(old_token, ttl: {1, :hour})See Guardian.refreshexchange(old_token, from_type, to_type, options)Exchanges one token for another of a different type. Especially useful to trade in a refresh token for an access one.Tokens are verified before performing the exchange to ensure that only valid tokens may be exchanged.Arguments:old_token - The existing token you wish to exchange.from_type - The type the old token must be. Can be given a list of types.to_type - The new type of token that you want back.options - The options to pass to the token module and callbacks.Options:Options may be used by your token module or callbacks.ttl - The ttl for the new tokenSee Guardian.exchange","ref":"Guardian.html","title":"Guardian","type":"behaviour"},{"doc":"An optional callback invoked after the token has been generated and signed.","ref":"Guardian.html#c:after_encode_and_sign/4","title":"Guardian.after_encode_and_sign/4","type":"callback"},{"doc":"An optional callback invoked after sign in has been called.By returning an error the sign in will be halted.Note that if you return an error, a token still may have been generated.","ref":"Guardian.html#c:after_sign_in/5","title":"Guardian.after_sign_in/5","type":"callback"},{"doc":"An optional callback invoked before sign out has happened.","ref":"Guardian.html#c:before_sign_out/3","title":"Guardian.before_sign_out/3","type":"callback"},{"doc":"An optional callback that allows the claims to be modified while they're being built.This is useful to hook into the encoding lifecycle.","ref":"Guardian.html#c:build_claims/3","title":"Guardian.build_claims/3","type":"callback"},{"doc":"Decodes a token using the configuration of the implementation module.This will, using that configuration, delegate to the token module.Once the token module has decoded the token, your implementation module has an opportunity to further verify the claims contained in the token using the verify_claims callback.LifecycleOnce called, a number of callbacks will be invoked on the implementation module:verify_claims - add custom claim verification, returns an error if the claims are not validon_verify - called after a successful verificationOptionsThe options will be passed through to the implementation / token modules and the appropriate callbacks.See the documentation for your implementation / token modules for more information on which options are available.","ref":"Guardian.html#decode_and_verify/4","title":"Guardian.decode_and_verify/4","type":"function"},{"doc":"Creates a signed token for a resource.The actual encoding depends on the implementation module which should be referenced for specifics.LifecycleOnce called, a number of callbacks will be invoked on the implementation module:subject_for_token - gets the subject from the resourcebuild_claims - allows the implementation module to add or modify claims before the token is createdafter_encode_and_signOptionsThe options will be passed through to the implementation / token modules and the appropriate callbacks.ttl - How long to keep the token alive for. If not included the default will be used.token_type - The type of token to generate if different from the default.The ttl option should take {integer, unit} where unit is one of::second | :seconds:minute | :minutes:hour | :hours:week | :weeksSee the documentation for your implementation / token module for more information on which options are available for your implementation / token module.","ref":"Guardian.html#encode_and_sign/4","title":"Guardian.encode_and_sign/4","type":"function"},{"doc":"Exchanges one token for another with different token types.The token is first decoded and verified to ensure that there is no escalation Of privileges.Tokens must have their type included in the from_type argument.Lifecycle&lt;TokenModule&gt;.exchange - exchange the old token for the new one&lt;ImplModule&gt;.on_exchange - will be invoked after the exchange happensOptionsAll options are passed through all calls to the token module and appropriate callbacks.","ref":"Guardian.html#exchange/5","title":"Guardian.exchange/5","type":"function"},{"doc":"An optional callback invoked when a token is exchanged.","ref":"Guardian.html#c:on_exchange/3","title":"Guardian.on_exchange/3","type":"callback"},{"doc":"An optional callback invoked when a token is refreshed.","ref":"Guardian.html#c:on_refresh/3","title":"Guardian.on_refresh/3","type":"callback"},{"doc":"An optional callback invoked when a token is revoked.","ref":"Guardian.html#c:on_revoke/3","title":"Guardian.on_revoke/3","type":"callback"},{"doc":"An optional callback invoked after the claims have been validated.","ref":"Guardian.html#c:on_verify/3","title":"Guardian.on_verify/3","type":"callback"},{"doc":"Returns an inspection of the token (at least claims) without any verification.This should not be relied on since there is no verification.The implementation is provided by the implementation module specified. See the documentation for your implementation / token module for full details.","ref":"Guardian.html#peek/2","title":"Guardian.peek/2","type":"function"},{"doc":"Refreshes a token keeping all main claims intact.Optionsttl - How long to keep the token alive for. If not included the default will be used.The ttl option should take {integer, unit} where unit is one of::second | :seconds:minute | :minutes:hour | :hours:day | :days:week | :weeksSee documentation for your token module for other options.","ref":"Guardian.html#refresh/3","title":"Guardian.refresh/3","type":"function"},{"doc":"Fetches the resource that is represented by claims.For JWT this would normally be found in the sub field.","ref":"Guardian.html#c:resource_from_claims/1","title":"Guardian.resource_from_claims/1","type":"callback"},{"doc":"Fetch the resource and claims directly from a token.This is a convenience function that first decodes the token using Guardian.decode_and_verify/4 and then loads the resource.","ref":"Guardian.html#resource_from_token/4","title":"Guardian.resource_from_token/4","type":"function"},{"doc":"Revoke a token.Note: This is entirely dependent on the token module and callbacks.Lifecycle&lt;TokenModule&gt;.revoke&lt;ImplModule&gt;.on_revokeOptionsThe options are passed through to the token module and callback so check the documentation for your token module.","ref":"Guardian.html#revoke/3","title":"Guardian.revoke/3","type":"function"},{"doc":"Converts keys in a map or list of maps to strings.","ref":"Guardian.html#stringify_keys/1","title":"Guardian.stringify_keys/1","type":"function"},{"doc":"Fetches the subject for a token for the provided resource and claims The subject should be a short identifier that can be used to identify the resource.","ref":"Guardian.html#c:subject_for_token/2","title":"Guardian.subject_for_token/2","type":"callback"},{"doc":"Provides the current system time in seconds.","ref":"Guardian.html#timestamp/0","title":"Guardian.timestamp/0","type":"function"},{"doc":"An optional callback to add custom verification to claims when decoding a token.Returning {:ok, claims} will allow the decoding to continue. Returning {:error, reason} will stop the decoding and return the error.","ref":"Guardian.html#c:verify_claims/2","title":"Guardian.verify_claims/2","type":"callback"},{"doc":"","ref":"Guardian.html#t:conditional_tuple/0","title":"Guardian.conditional_tuple/0","type":"type"},{"doc":"","ref":"Guardian.html#t:options/0","title":"Guardian.options/0","type":"type"},{"doc":"Working with configuration for guardian.","ref":"Guardian.Config.html","title":"Guardian.Config","type":"module"},{"doc":"Resolves possible values from a configuration.{m, f, a} - Calls function f on module m with arguments a and returns the resultvalue - Returns other values as is","ref":"Guardian.Config.html#resolve_value/1","title":"Guardian.Config.resolve_value/1","type":"function"},{"doc":"Configuration values can be given using the following types:{MyModule, :func, [:some, :args]} Calls the function on the module with argsany other value","ref":"Guardian.Config.html#t:config_value/0","title":"Guardian.Config.config_value/0","type":"type"},{"doc":"Optional Behaviour for creating error handlers for Guardian.Plug.Pipeline.Error handlerWhen using plugs, you'll need to specify an error handler module.The error_handler module requires an auth_error function that receives the conn, the reason tuple and the options.defmodule MyApp.AuthErrorHandler do @behaviour Guardian.Plug.ErrorHandler @impl Guardian.Plug.ErrorHandler def auth_error(conn, {type, reason}, opts) do ... end endBy default, Guardian will emit types of::unauthorized:invalid_token:already_authenticated:no_resource_found","ref":"Guardian.Plug.ErrorHandler.html","title":"Guardian.Plug.ErrorHandler","type":"behaviour"},{"doc":"","ref":"Guardian.Plug.ErrorHandler.html#c:auth_error/3","title":"Guardian.Plug.ErrorHandler.auth_error/3","type":"callback"},{"doc":"Provides a behaviour that specifies how to fetch the secret for the token.use Guardian.Token.JWT.SecretFetcher to provide default implementations of each function.","ref":"Guardian.Token.Jwt.SecretFetcher.html","title":"Guardian.Token.Jwt.SecretFetcher","type":"behaviour"},{"doc":"fetch_signing_secret fetches the secret to sign.","ref":"Guardian.Token.Jwt.SecretFetcher.html#c:fetch_signing_secret/2","title":"Guardian.Token.Jwt.SecretFetcher.fetch_signing_secret/2","type":"callback"},{"doc":"Fetches the secret to verify a token.It is provided with the tokens headers in order to lookup the secret.","ref":"Guardian.Token.Jwt.SecretFetcher.html#c:fetch_verifying_secret/3","title":"Guardian.Token.Jwt.SecretFetcher.fetch_verifying_secret/3","type":"callback"},{"doc":"Generates a secret and prints it to the terminal.mix guardian.gen.secret [length]By default, mix guardian.gen.secret generates a key 64 characters long.The minimum value for length is 32.","ref":"Mix.Tasks.Guardian.Gen.Secret.html","title":"Mix.Tasks.Guardian.Gen.Secret","type":"task"},{"doc":"The behaviour module for all token modules.Token modules are responsible for all the heavy lifting in Guardian.","ref":"Guardian.Token.html","title":"Guardian.Token","type":"behaviour"},{"doc":"Build the default claims for the token.","ref":"Guardian.Token.html#c:build_claims/5","title":"Guardian.Token.build_claims/5","type":"callback"},{"doc":"Create the token including serializing and signing.","ref":"Guardian.Token.html#c:create_token/3","title":"Guardian.Token.create_token/3","type":"callback"},{"doc":"Decode the token. Without verification of the claims within it.","ref":"Guardian.Token.html#c:decode_token/3","title":"Guardian.Token.decode_token/3","type":"callback"},{"doc":"Exchange a token from one type to another.","ref":"Guardian.Token.html#c:exchange/5","title":"Guardian.Token.exchange/5","type":"callback"},{"doc":"Inspect the contents of the token without validation or signature checking.","ref":"Guardian.Token.html#c:peek/2","title":"Guardian.Token.peek/2","type":"callback"},{"doc":"Refresh a token.","ref":"Guardian.Token.html#c:refresh/3","title":"Guardian.Token.refresh/3","type":"callback"},{"doc":"Revoke a token (if appropriate).","ref":"Guardian.Token.html#c:revoke/4","title":"Guardian.Token.revoke/4","type":"callback"},{"doc":"Generate a unique id for a token.","ref":"Guardian.Token.html#c:token_id/0","title":"Guardian.Token.token_id/0","type":"callback"},{"doc":"Verify the claims of a token.","ref":"Guardian.Token.html#c:verify_claims/3","title":"Guardian.Token.verify_claims/3","type":"callback"},{"doc":"","ref":"Guardian.Token.html#t:claims/0","title":"Guardian.Token.claims/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:decoding_error/0","title":"Guardian.Token.decoding_error/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:encoding_error/0","title":"Guardian.Token.encoding_error/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:resource/0","title":"Guardian.Token.resource/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:secret_error/0","title":"Guardian.Token.secret_error/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:signing_error/0","title":"Guardian.Token.signing_error/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:token/0","title":"Guardian.Token.token/0","type":"type"},{"doc":"","ref":"Guardian.Token.html#t:ttl/0","title":"Guardian.Token.ttl/0","type":"type"},{"doc":"Deals with things JWT. This module should not be used directly.It is intended to be used by Guardian on behalf of your implementation as it's token module.Token types are encoded in the typ field.ConfigurationConfiguration should be added to the implementation module in either the configuration file or as options to use GuardianRequiredissuer - The issuer of the token. Your application name/idsecret_key - The secret key to use for the implementation module. This may be any resolvable value for Guardian.ConfigOptionaltoken_verify_module - default Guardian.Token.Jwt.Verify. The module that verifies the claimsallowed_algos - The allowed algos to use for encoding and decoding. See JOSE for available. Default [&quot;HS512&quot;]ttl - The default time to live for all tokens. See the type in Guardian.ttl. The default by Guardian.Token.JWT is {4, :weeks}token_ttl a map of token_type to ttl. Set specific ttls for specific types of tokensallowed_drift The drift that is allowed when decoding/verifying a token in milli secondsverify_issuer Verify that the token was issued by the configured issuer. Default falsesecret_fetcher A module used to fetch the secret. Default: Guardian.Token.Jwt.SecretFetcherOptions:These options are available to encoding and decoding:secret The secret key to use for signingheaders The Jose headers that should be usedallowed_algos - A list of allowable algostoken_type - Override the default token type. The default is &quot;access&quot;ttl - The time to live. See Guardian.Token.ttl typeExample# encode a simple token {:ok, token, claims} = MyApp.Tokens.encode_and_sign(resource) # encode a token with custom claims {:ok, token, claims} = MyApp.Tokens.encode_and_sign(resource, %{some: &quot;claim&quot;}) # encode a token with a custom type {:ok, token, claims} = MyApp.Tokens.encode_and_sign(resource, %{}, token_type: &quot;refresh&quot;) # encode a token with custom options {:ok, token, claims} = MyApp.Tokens.encode_and_sign( resource, %{}, secret: {MyModule, :get_my_secret, [&quot;some&quot;, &quot;args&quot;]}, ttl: {4, :weeks}, token_type: &quot;refresh&quot; ) # decode a token {:ok, claims} = MyApp.Tokens.decode_and_verify(token) # decode a token and check literal claims {:ok, claims} = MyApp.Tokens.decode_and_verify(token, %{&quot;typ&quot; =&gt; &quot;refresh&quot;}) # decode a token and check literal claims with options {:ok, claims} = MyApp.Tokens.decode_and_verify(token, %{&quot;typ&quot; =&gt; &quot;refresh&quot;}, secret: {MyModule, :get_my_secret, [&quot;some&quot;, &quot;args&quot;]}) # exchange a token {:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Tokens.exchange(old_token, [&quot;access&quot;, &quot;refresh&quot;], &quot;access&quot;) # exchange a token with options {:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Tokens.exchange(old_token, [&quot;access&quot;, &quot;refresh&quot;], &quot;access&quot; secret: {MyModule, :get_my_secret, [&quot;some&quot;, &quot;args&quot;]}, ttl: {1, :hour}) # refresh a token using defaults {:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Tokens.refresh(old_token) # refresh a token using options {:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Tokens.refresh(old_token, ttl: {1, :week}, secret: {MyMod, :get_secret, [&quot;some&quot;, &quot;args&quot;}) Token verify moduleThe token verify module by default is Guardian.Token.Jwt.Verify.This module implements the Guardian.Token.Verify behaviour. To customize your token validation you have 2 options.Implement the verify_claims callback on your implementationuse Guardian.Token.Verify in your own module and use that.To create your own verify module use Guardian.Token.Verify and configure your implementation to use it either through config files or when you setup your implementation.defmodule MyApp.Tokens do use Guardian, otp_app: :my_app, token_verify_module: MyVerifyModule # ... snip endSecretFetcherWhen you need dynamic secret verification, you should use a custom Guardian.Token.Jwt.SecretFetcher module.This will allow you to use the header values to determine dynamically the key that should be used.defmodule MyCustomSecretFetcher do use Guardian.Token.Jwt.SecretFetcher def fetch_signing_secret(impl_module, opts) do # fetch the secret for signing end def fetch_verifying_secret(impl_module, token_headers, opts) do # fetch the secret for verifying the token end endIf the signing secret contains a &quot;kid&quot; (https://tools.ietf.org/html/rfc7515#section-4.1.4) it will be passed along to the signature to provide a hint about which secret was used.This can be useful for specifying which public key to use during verification if you're using a public/private key rotation strategy.An example implementation of this can be found here: https://gist.github.com/mpinkston/469009001b694d3ca162894d74c9bfe3","ref":"Guardian.Token.Jwt.html","title":"Guardian.Token.Jwt","type":"module"},{"doc":"Builds the default claims for all JWT tokens.Note:aud is set to the configured issuer unless aud is setOptions:Options may override the defaults found in the configuration.token_type - Override the default token typettl - The time to live. See Guardian.Token.ttl type","ref":"Guardian.Token.Jwt.html#build_claims/5","title":"Guardian.Token.Jwt.build_claims/5","type":"function"},{"doc":"Create a token. Uses the claims, encodes and signs the token.The signing secret will be found first from the options. If not specified the secret key from the configuration will be used.Configuration:secret_key The secret key to use for signingOptions:secret The secret key to use for signingheaders The Jose headers that should be usedallowed_algosThe secret may be in the form of any resolved value from Guardian.Config.","ref":"Guardian.Token.Jwt.html#create_token/3","title":"Guardian.Token.Jwt.create_token/3","type":"function"},{"doc":"Decodes the token and validates the signature.Options:secret - Override the configured secret. Guardian.Config.config_value is validallowed_algos - A list of allowable algos","ref":"Guardian.Token.Jwt.html#decode_token/3","title":"Guardian.Token.Jwt.decode_token/3","type":"function"},{"doc":"Exchange a token of one type to another.Type is encoded in the typ field.Options:secret - Override the configured secret. Guardian.Config.config_value is validallowed_algos - A list of allowable algosttl - The time to live. See Guardian.Token.ttl type","ref":"Guardian.Token.Jwt.html#exchange/5","title":"Guardian.Token.Jwt.exchange/5","type":"function"},{"doc":"Inspect the JWT without any validation or signature checking.Return an map with keys: headers and claims.","ref":"Guardian.Token.Jwt.html#peek/2","title":"Guardian.Token.Jwt.peek/2","type":"function"},{"doc":"Refresh the tokenOptions:secret - Override the configured secret. Guardian.Config.config_value is validallowed_algos - A list of allowable algosttl - The time to live. See Guardian.Token.ttl type","ref":"Guardian.Token.Jwt.html#refresh/3","title":"Guardian.Token.Jwt.refresh/3","type":"function"},{"doc":"Revoking a JWT by default does not do anything.You'll need to track the token in storage in some way and revoke in your implementation callbacks.See GuardianDb for an example.","ref":"Guardian.Token.Jwt.html#revoke/4","title":"Guardian.Token.Jwt.revoke/4","type":"function"},{"doc":"Generate unique token id.","ref":"Guardian.Token.Jwt.html#token_id/0","title":"Guardian.Token.Jwt.token_id/0","type":"function"},{"doc":"Verifies the claims.Options:token_verify_module - the module to use to verify the claims. Default Guardian.Token.Jwt.Verify","ref":"Guardian.Token.Jwt.html#verify_claims/3","title":"Guardian.Token.Jwt.verify_claims/3","type":"function"},{"doc":"Verifies standard jwt fields","ref":"Guardian.Token.Jwt.Verify.html","title":"Guardian.Token.Jwt.Verify","type":"module"},{"doc":"","ref":"Guardian.Token.Jwt.Verify.html#verify_claims/3","title":"Guardian.Token.Jwt.Verify.verify_claims/3","type":"function"},{"doc":"Interface for verifying tokens.This is intended to be used primarily by token modules but allows for a custom verification module to be created if the one that ships with your TokenModule is not quite what you want.","ref":"Guardian.Token.Verify.html","title":"Guardian.Token.Verify","type":"behaviour"},{"doc":"Checks that a time value is within the allowed_drift as configured for the provided module.Allowed drift is measured in seconds and represents the maximum amount of time a token may be expired for an still be considered valid.This is to deal with clock skew.","ref":"Guardian.Token.Verify.html#time_within_drift?/2","title":"Guardian.Token.Verify.time_within_drift?/2","type":"function"},{"doc":"Verify a single claim.You should also include a fallback for claims that you are not validating.def verify_claim(_mod, _key, claims, _opts), do: {:ok, claims}","ref":"Guardian.Token.Verify.html#c:verify_claim/4","title":"Guardian.Token.Verify.verify_claim/4","type":"callback"},{"doc":"For claims, check the values against the values found in claims_to_check. If there is a claim to check that does not pass verification, it fails.When the value of a claim is a list, it checks that all values of the same claim in claims_to_check are members of the list.","ref":"Guardian.Token.Verify.html#verify_literal_claims/3","title":"Guardian.Token.Verify.verify_literal_claims/3","type":"function"},{"doc":"Provides functions for the implementation module for dealing with Guardian in a Plug environment.defmodule MyApp.Tokens do use Guardian, otp_app: :my_app # ... snip endYour implementation module will be given a Plug module for interacting with plug.If you're using Guardian in your application most of the setters will be uninteresting. They're mostly for library authors and Guardian itself.The usual functions you'd use in your application are:sign_in(conn, resource, claims \\\\ %{}, opts \\\\ [])Sign in a resource for your application. This will generate a token for your resource according to your TokenModule and subject_for_token callback.sign_in will also cache the resource, claims, and token on the connection.conn = MyApp.Guardian.Plug.sign_in(conn, resource, my_custom_claims)If there is a session present the token will be stored in the session to provide traditional session based authentication.","ref":"Guardian.Plug.html","title":"Guardian.Plug","type":"module"},{"doc":"","ref":"Guardian.Plug.html#authenticated?/2","title":"Guardian.Plug.authenticated?/2","type":"function"},{"doc":"Puts a response cookie which replaces the previous remember_me cookie and is set to immediately expire on the client.Note that while this can be used as a cheap way to sign out, a malicious client could still access your server using the old JWT from the old cookie.In other words, this does not in any way invalidate the token you issued, it just makes a compliant client forget it.","ref":"Guardian.Plug.html#clear_remember_me/3","title":"Guardian.Plug.clear_remember_me/3","type":"function"},{"doc":"","ref":"Guardian.Plug.html#current_claims/2","title":"Guardian.Plug.current_claims/2","type":"function"},{"doc":"","ref":"Guardian.Plug.html#current_resource/2","title":"Guardian.Plug.current_resource/2","type":"function"},{"doc":"","ref":"Guardian.Plug.html#current_token/2","title":"Guardian.Plug.current_token/2","type":"function"},{"doc":"Provides the default key for the location of a token in the session and connection.","ref":"Guardian.Plug.html#default_key/0","title":"Guardian.Plug.default_key/0","type":"function"},{"doc":"","ref":"Guardian.Plug.html#find_token_from_cookies/2","title":"Guardian.Plug.find_token_from_cookies/2","type":"function"},{"doc":"","ref":"Guardian.Plug.html#maybe_halt/2","title":"Guardian.Plug.maybe_halt/2","type":"function"},{"doc":"","ref":"Guardian.Plug.html#put_current_claims/3","title":"Guardian.Plug.put_current_claims/3","type":"function"},{"doc":"","ref":"Guardian.Plug.html#put_current_resource/3","title":"Guardian.Plug.put_current_resource/3","type":"function"},{"doc":"","ref":"Guardian.Plug.html#put_current_token/3","title":"Guardian.Plug.put_current_token/3","type":"function"},{"doc":"","ref":"Guardian.Plug.html#put_session_token/3","title":"Guardian.Plug.put_session_token/3","type":"function"},{"doc":"Sets a token of type refresh directly on a cookie.The max_age of the cookie till be the expire time of the Token, if available If the token does not have an exp,t the default will be 30 days.The max age can be overridden by setting the cookie option config.","ref":"Guardian.Plug.html#remember_me/5","title":"Guardian.Plug.remember_me/5","type":"function"},{"doc":"","ref":"Guardian.Plug.html#remember_me_from_token/5","title":"Guardian.Plug.remember_me_from_token/5","type":"function"},{"doc":"","ref":"Guardian.Plug.html#session_active?/1","title":"Guardian.Plug.session_active?/1","type":"function"},{"doc":"","ref":"Guardian.Plug.html#sign_in/5","title":"Guardian.Plug.sign_in/5","type":"function"},{"doc":"","ref":"Guardian.Plug.html#sign_out/3","title":"Guardian.Plug.sign_out/3","type":"function"},{"doc":"This plug ensures that a valid token was provided and has been verified on the request.If one is not found, the auth_error will be called with :unauthenticatedThis, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyOptions:claims - The literal claims to check to ensure that a token is validmax_age - If the token has an &quot;auth_time&quot; claim, check it is not older than the maximum age.key - The location to find the information in the connection. Defaults to: defaulthalt - Whether to halt the connection in case of error. Defaults to trueExample# setup the upstream pipeline plug Guardian.Plug.EnsureAuthenticated, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.EnsureAuthenticated, key: :secret","ref":"Guardian.Plug.EnsureAuthenticated.html","title":"Guardian.Plug.EnsureAuthenticated","type":"module"},{"doc":"This plug ensures that a resource is not logged in.If one is not found, the auth_error will be called with :already_authenticatedThis, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyOptions:key - The location to find the information in the connection. Defaults to: defaulthalt - Whether to halt the connection in case of error. Defaults to trueExample # setup the upstream pipeline plug Guardian.Plug.EnsureNotAuthenticated plug Guardian.Plug.EnsureNotAuthenticated, key: :secret","ref":"Guardian.Plug.EnsureNotAuthenticated.html","title":"Guardian.Plug.EnsureNotAuthenticated","type":"module"},{"doc":"Calculates keys for use with plug.The keys relate to where in the session/connection the data that Guardian deals in will be stored.token, claims, resource are all keyed. token, claims, resource are all stored on the conn. token is stored in the session if a session is found.","ref":"Guardian.Plug.Keys.html","title":"Guardian.Plug.Keys","type":"module"},{"doc":"","ref":"Guardian.Plug.Keys.html#key_from_other/1","title":"Guardian.Plug.Keys.key_from_other/1","type":"function"},{"doc":"This plug loads the resource associated with a previously validated token. Tokens are found and validated using the Verify* plugs.By default, load resource will return an error if no resource can be found. You can override this behaviour using the allow_blank: true option.If allow_blank is not set to true, the plug will return an error if no resource can be found with :no_resource_foundThis, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyOptions:allow_blank - boolean. If set to true, will try to load a resource but will not fail if no resource is found.key - The location to find the information in the connection. Defaults to: defaulthalt - Whether to halt the connection in case of error. Defaults to trueExample# setup the upstream pipeline plug Guardian.Plug.LoadResource, allow_blank: true plug Guardian.Plug.LoadResource, key: :secret","ref":"Guardian.Plug.LoadResource.html","title":"Guardian.Plug.LoadResource","type":"module"},{"doc":"Helps to build plug pipelines for use with Guardian and associated plugs.All Guardian provided plugs have a number of features.They take a :key option to know where to store information in the session and connectionThey require a reference to the implementation (the module that use Guardian)They require a reference to an error handling moduleThese references are passed through the connection so they must be put in place before the Guardian Plugs. By using a pipeline this is taken care of for you.The easiest way to use Guardian.Plug.Pipeline is to create a module that defines your pipeline.defmodule MyApp.AuthPipeline do use Guardian.Plug.Pipeline, otp_app: :my_app, module: MyApp.Tokens, error_handler: MyApp.AuthErrorHandler @claims %{iss: &quot;IssuerApp&quot;} plug Guardian.Plug.VerifySession, claims: @claims plug Guardian.Plug.VerifyHeader, claims: @claims, scheme: &quot;Bearer&quot; plug Guardian.Plug.EnsureAuthenticated plug Guardian.Plug.LoadResource, allow_blank: true endWhen you want to use the pipeline you just use it like a normal plug.plug MyApp.AuthPipelineThis pipeline will look for tokens in either the session (it's ok if it's not loaded) followed by the header if one wasn't found in the session.We then ensure that we found a token and fail if not.Given that we found a token, we then attempt to load the resource the token refers to, failing if one is not found.Customizing your pipelineOnce you've created a pipeline, you can customize it when you call it with options.plug MyApp.AuthPipeline, module: MyApp.ADifferentGuardianModule # OR plug MyApp.AuthPipeline, key: :impersonateOptionsYou can provide options to the pipeline when you use Guardian.Plug.Pipeline or you can provide them when you call the plug.Additionally, for every option other than :otp_app you can use elixir configuration, the use options, or inline options.:otp_app - The otp app where the pipeline modules can be found:module - The Guardian implementation module:error_handler - The error handler module:key - The key to useKeysUsing keys allows you to specify locations in the session/connection where the tokens and resources will be placed. This allows multiple authenticated tokens to be in play for a single request. This is useful for impersonation or higher security areas where you can have a specific set of privileges and still be logged in.Error handlerWhen using plugs, you'll need to specify an error handler moduleSee Guardian.Plug.ErrorHandler documentation for more details.Inline pipelinesIf you want to define your pipeline inline, you can do so by using Guardian.Plug.Pipeline as a plug itself.You must supply the module and error handler inline if you do this.plug Guardian.Plug.Pipeline, module: MyApp.Tokens, error_handler: MyApp.AuthErrorHandler plug Guardian.VerifyHeader, scheme: &quot;Bearer&quot;Inline pipelines are also good to change the error handler that you want to use.Note that you must set the pipeline before using other guardian plugs.# Use the MyApp.AuthErrorHandler for downstream Guardian plugs plug Guardian.Plug.Pipeline, module: MyApp.Tokens, error_handler: MyApp.AuthErrorHandler plug Guardian.VerifyHeader, scheme: &quot;Bearer&quot; # Now change out the error handler for plugs downstream of this one. plug Guardian.Plug.Pipeline, error_handler: MyApp.SpecialAuthErrorHandler","ref":"Guardian.Plug.Pipeline.html","title":"Guardian.Plug.Pipeline","type":"module"},{"doc":"Create your very own Guardian.Plug.PipelineUsing this macro will make your module into a plug builder.It will provide your pipeline with the Guardian implementation module and error handler so that it can be used within your pipeline and downstream.","ref":"Guardian.Plug.Pipeline.html#__using__/1","title":"Guardian.Plug.Pipeline.__using__/1","type":"macro"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#current_error_handler/1","title":"Guardian.Plug.Pipeline.current_error_handler/1","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#current_key/1","title":"Guardian.Plug.Pipeline.current_key/1","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#current_module/1","title":"Guardian.Plug.Pipeline.current_module/1","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#fetch_error_handler/2","title":"Guardian.Plug.Pipeline.fetch_error_handler/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#fetch_error_handler!/2","title":"Guardian.Plug.Pipeline.fetch_error_handler!/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#fetch_key/2","title":"Guardian.Plug.Pipeline.fetch_key/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#fetch_module/2","title":"Guardian.Plug.Pipeline.fetch_module/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#fetch_module!/2","title":"Guardian.Plug.Pipeline.fetch_module!/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#put_error_handler/2","title":"Guardian.Plug.Pipeline.put_error_handler/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#put_key/2","title":"Guardian.Plug.Pipeline.put_key/2","type":"function"},{"doc":"","ref":"Guardian.Plug.Pipeline.html#put_module/2","title":"Guardian.Plug.Pipeline.put_module/2","type":"function"},{"doc":"WARNING! Use of this plug MAY allow a session to be maintained indefinitely without primary authentication by issuing new refresh tokens off the back of previous (still valid) tokens. Especially if your resource_from_claims implementation does not check resource validity (in a user database or whatever), you SHOULD then at least make such checks in the sliding_cookie/3 implementation to make sure the resource still exists, is valid and permitted.Indefinite sessions can be prevented by using a :max_age configuration (which will globally affect the validation of all tokens with an auth_time claim) or by using the :max_age option when validating, and the :auth_time option when encoding tokens in response to user login. For many simple integrations with Phoenix simply using the :max_age configuration will provide a desirable behaviour. This is subject to using JWT tokens, or another token back end which supports the auth_time and max_age features.Looks for a valid token in the request cookies, and replaces it, if:a. A valid unexpired token is found in the request cookies. b. There is a :sliding_cookie configuration (or plug option). c. The token age (since issue) exceeds that configuration. d. The implementation module sliding_cookie/3 returns {:ok, new_claims}.Otherwise the plug does nothing.The implementation module MUST implement the sliding_cookie/3 function if this plug is used. The return value, if an updated cookie is approved of, should be {:ok, new_claims}. The sliding_cookie/3 function should take any security action (such as checking a database to check a user has not been disabled). Anything else returned will be taken as an indication that the cookie should not refreshed.The only case whereby the error handler is employed is if the sliding_cookie/3 function is not provided, in which case it is called with a type of :implementation_fault and reason :no_sliding_cookie_fn.This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyNothing is done with the token, refreshed or not, no errors are handled as validity and expiry can be checked by the VerifyCookie and EnsureAuthenticated plugs respectively.Options::key - The location of the token (default :default):sliding_cookie - The minimum TTL remaining after which a replacement will be issued. Defaults to configured values.:halt - Whether to halt the connection in case of error. Defaults to true.The :sliding_cookie config (or plug option) should be the same format as :ttl, for example {1, :hour}, and obviously it should be less than the prevailing :ttl.","ref":"Guardian.Plug.SlidingCookie.html","title":"Guardian.Plug.SlidingCookie","type":"module"},{"doc":"Looks for and validates a token found in the request cookies.This module is deprecated in favor of using Guardian.Plug.VerifySession or the Guardian.Plug.VerifyHeader plug with the :refresh_from_cookie optionIn the case where either:The cookies are not loadedA token is already found for :keyThis plug will not do anything.This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyIf a token is found but is invalid, the error handler will be called with auth_error(conn, {:invalid_token, reason}, opts)If a token is expired, the error handler WON'T be called, the error can be handled with the ensure_authenticated plugOnce a token has been found it will be exchanged for an access (default) token. This access token will be placed into the session and connection.They will be available using Guardian.Plug.current_claims/2 and Guardian.Plug.current_token/2.Tokens from cookies should be of type refresh and have a relatively long life. They will be exchanged for access tokens (default).Options::key - The location of the token (default :default):exchange_from - The type of the cookie (default &quot;refresh&quot;):exchange_to - The type of token to provide. Defaults to the implementation modules default_type:ttl - The time to live of the exchanged token. Defaults to configured values.:halt - Whether to halt the connection in case of error. Defaults to true","ref":"Guardian.Plug.VerifyCookie.html","title":"Guardian.Plug.VerifyCookie","type":"module"},{"doc":"","ref":"Guardian.Plug.VerifyCookie.html#refresh_from_cookie/2","title":"Guardian.Plug.VerifyCookie.refresh_from_cookie/2","type":"function"},{"doc":"Looks for and validates a token found in the Authorization header.In the case where either:A token is already found for :keyNo token is found in the Authorization header.This plug will not do anything.This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyIf a token is found but is invalid, the error handler will be called with auth_error(conn, {:invalid_token, reason}, opts)Once a token has been found it will be decoded, the token and claims will be put onto the connection.They will be available using Guardian.Plug.current_claims/2 and Guardian.Plug.current_token/2Options:claims - The literal claims to check to ensure that a token is validmax_age - If the token has an &quot;auth_time&quot; claim, check it is not older than the maximum age.header_name - The name of the header to search for a token. Defaults to authorization.scheme - The prefix for the token in the header. Defaults to Bearer. :none will not use a prefix.key - The location to store the information in the connection. Defaults to: defaulthalt - Whether to halt the connection in case of error. Defaults to true.:refresh_from_cookie - Looks for and validates a token found in the request cookies. (default false)Refresh from cookie option:key - The location of the token (default :default):exchange_from - The type of the cookie (default &quot;refresh&quot;):exchange_to - The type of token to provide. Defaults to the implementation modules default_type:ttl - The time to live of the exchanged token. Defaults to configured values.:halt - Whether to halt the connection in case of error. Defaults to trueExample# setup the upstream pipeline plug Guardian.Plug.VerifyHeader, claims: %{typ: &quot;access&quot;}This will check the authorization header for a tokenAuthorization: Bearer &lt;token&gt;This token will be placed into the connection depending on the key and can be accessed with Guardian.Plug.current_token and Guardian.Plug.current_claims.ORMyApp.ImplementationModule.current_token and MyApp.ImplementationModule.current_claims.","ref":"Guardian.Plug.VerifyHeader.html","title":"Guardian.Plug.VerifyHeader","type":"module"},{"doc":"Looks for and validates a token found in the session.In the case where either:The session is not loadedA token is already found for :keyNo token is found on the sessionThis plug will not do anything.This, like all other Guardian plugs, requires a Guardian pipeline to be setup. It requires an implementation module, an error handler and a key.These can be set either:Upstream on the connection with plug Guardian.PipelineUpstream on the connection with Guardian.Pipeline.{put_module, put_error_handler, put_key}Inline with an option of :module, :error_handler, :keyIf a token is found but is invalid, the error handler will be called with auth_error(conn, {:invalid_token, reason}, opts).Once a token has been found it will be decoded, the token and claims will be put onto the connection.They will be available using Guardian.Plug.current_claims/2 and Guardian.Plug.current_token/2.Options::refresh_from_cookie - Looks for and validates a token found in the request cookies. (default false)Refresh from cookie option:key - The location of the token (default :default):exchange_from - The type of the cookie (default &quot;refresh&quot;):exchange_to - The type of token to provide. Defaults to the implementation modules default_type:ttl - The time to live of the exchanged token. Defaults to configured values.:halt - Whether to halt the connection in case of error. Defaults to true","ref":"Guardian.Plug.VerifySession.html","title":"Guardian.Plug.VerifySession","type":"module"},{"doc":"An optional plugin to Guardian to provide permissions for your tokens.These can be used for any token types since they only work on the claims.Permissions are set on a per implementation module basis. Each implementation module can have their own sets. Permissions are similar in concept to OAuth2 scopes. They're encoded into a token and the permissions granted last as long as the token does. This makes it unsuitable for highly dynamic permission schemes. They're best left to an application to implement.For example. (at the time of writing) some of the Facebook permissions are:public_profileuser_about_meuser_actions.booksuser_actions.fitnessuser_actions.musicTo create permissions for your application similar to these:defmodule MyApp.Auth.Token do use Guardian, otp_app: :my_app, permissions: %{ default: [:public_profile, :user_about_me] user_actions: %{ books: 0b1, fitness: 0b100, music: 0b1000, } } use Guardian.Permissions, encoding: Guardian.Permissions.BitwiseEncoding # Per default permissions will be encoded Bitwise, but other encoders also exist # * Guardian.Permissions.TextEncoding # * Guardian.Permissions.AtomEncoding # It is even possible to supply your own encoding module # snip def build_claims(claims, _resource, opts) do claims = claims |&gt; encode_permissions_into_claims!(Keyword.get(opts, :permissions)) {:ok, claims} end endThis will take the permission set in the opts at :permissions and put it into the &quot;pems&quot; key of the claims as a map of %{set_name =&gt; integer}.The permissions can be defined as a list (positional value based on index) or a map where the value for each permission is manually provided.They can be provided either as options to use Guardian or in the config for your implementation module.Once you have a token, you can interact with it.# Get the encoded permissions from the claims found_perms = MyApp.Auth.Token.decode_permissions_from_claims(claims) # Check if all permissions are present has_all_these_things? = claims |&gt; MyApp.Auth.Token.decode_permissions_from_claims |&gt; MyApp.Auth.Token.all_permissions?(%{default: [:user_about_me, :public_profile]}) # Checks if any permissions are present show_any_media_things? = claims |&gt; MyApp.Auth.Token.decode_permissions_from_claims |&gt; MyApp.Auth.Token.any_permissions?(%{user_actions: [:books, :fitness, :music]})Using with PlugTo use a plug for ensuring permissions you can use the Guardian.Permissions module as part of a Guardian pipeline.# After a pipeline has setup the implementation module and error handler # Ensure that both the `public_profile` and `user_actions.books` permissions # are present in the token plug Guardian.Permissions, ensure: %{default: [:public_profile], user_actions: [:books]} # Allow the request to continue when the token contains any of the permission sets specified plug Guardian.Permissions, one_of: [ %{default: [:public_profile], user_actions: [:books]}, %{default: [:public_profile], user_actions: [:music]}, ] # Look for permissions for a token in a different location plug Guardian.Permissions, key: :impersonate, ensure: %{default: [:public_profile]}If the token satisfies either the permissions listed in ensure or one of the sets in the one_of key the request will continue. If not, then auth_error callback will be called on the error handler with auth_error(conn, {:unauthorized, reason}, options).","ref":"Guardian.Permissions.html","title":"Guardian.Permissions","type":"module"},{"doc":"See Guardian.Permissions.Plug.call/2.","ref":"Guardian.Permissions.html#call/2","title":"Guardian.Permissions.call/2","type":"function"},{"doc":"See Guardian.Permissions.Plug.init/1.","ref":"Guardian.Permissions.html#init/1","title":"Guardian.Permissions.init/1","type":"function"},{"doc":"Provides an encoded version of all permissions, and all possible future permissions for a permission set.","ref":"Guardian.Permissions.html#max/0","title":"Guardian.Permissions.max/0","type":"function"},{"doc":"","ref":"Guardian.Permissions.html#t:input_label/0","title":"Guardian.Permissions.input_label/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:input_permissions/0","title":"Guardian.Permissions.input_permissions/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:input_set/0","title":"Guardian.Permissions.input_set/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:label/0","title":"Guardian.Permissions.label/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:permission/0","title":"Guardian.Permissions.permission/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:permission_label/0","title":"Guardian.Permissions.permission_label/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:permission_set/0","title":"Guardian.Permissions.permission_set/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:plug_option/0","title":"Guardian.Permissions.plug_option/0","type":"type"},{"doc":"","ref":"Guardian.Permissions.html#t:t/0","title":"Guardian.Permissions.t/0","type":"type"},{"doc":"Atom encoding for permissions.","ref":"Guardian.Permissions.AtomEncoding.html","title":"Guardian.Permissions.AtomEncoding","type":"module"},{"doc":"Callback implementation for Guardian.Permissions.PermissionEncoding.decode/3.","ref":"Guardian.Permissions.AtomEncoding.html#decode/3","title":"Guardian.Permissions.AtomEncoding.decode/3","type":"function"},{"doc":"Callback implementation for Guardian.Permissions.PermissionEncoding.encode/3.","ref":"Guardian.Permissions.AtomEncoding.html#encode/3","title":"Guardian.Permissions.AtomEncoding.encode/3","type":"function"},{"doc":"Bitwise encoding for permissions.","ref":"Guardian.Permissions.BitwiseEncoding.html","title":"Guardian.Permissions.BitwiseEncoding","type":"module"},{"doc":"Callback implementation for Guardian.Permissions.PermissionEncoding.decode/3.","ref":"Guardian.Permissions.BitwiseEncoding.html#decode/3","title":"Guardian.Permissions.BitwiseEncoding.decode/3","type":"function"},{"doc":"Callback implementation for Guardian.Permissions.PermissionEncoding.encode/3.","ref":"Guardian.Permissions.BitwiseEncoding.html#encode/3","title":"Guardian.Permissions.BitwiseEncoding.encode/3","type":"function"},{"doc":"Behavior for the permission encoding.","ref":"Guardian.Permissions.PermissionEncoding.html","title":"Guardian.Permissions.PermissionEncoding","type":"behaviour"},{"doc":"","ref":"Guardian.Permissions.PermissionEncoding.html#c:decode/3","title":"Guardian.Permissions.PermissionEncoding.decode/3","type":"callback"},{"doc":"","ref":"Guardian.Permissions.PermissionEncoding.html#c:encode/3","title":"Guardian.Permissions.PermissionEncoding.encode/3","type":"callback"},{"doc":"Text encoding for permissions.","ref":"Guardian.Permissions.TextEncoding.html","title":"Guardian.Permissions.TextEncoding","type":"module"},{"doc":"Callback implementation for Guardian.Permissions.PermissionEncoding.decode/3.","ref":"Guardian.Permissions.TextEncoding.html#decode/3","title":"Guardian.Permissions.TextEncoding.decode/3","type":"function"},{"doc":"Callback implementation for Guardian.Permissions.PermissionEncoding.encode/3.","ref":"Guardian.Permissions.TextEncoding.html#encode/3","title":"Guardian.Permissions.TextEncoding.encode/3","type":"function"},{"doc":"","ref":"Guardian.MalformedReturnValueError.html","title":"Guardian.MalformedReturnValueError","type":"exception"},{"doc":"","ref":"Guardian.Permissions.PermissionNotFoundError.html","title":"Guardian.Permissions.PermissionNotFoundError","type":"exception"},{"doc":"","ref":"Guardian.Plug.UnauthenticatedError.html","title":"Guardian.Plug.UnauthenticatedError","type":"exception"},{"doc":"GuardianAn authentication library for use with Elixir applications. Guardian is a token based authentication library for use with Elixir applications.Guardian remains a functional system. It integrates with Plug but can be used outside of it. If you're implementing a TCP/UDP protocol directly or want to utilize your authentication via channels in Phoenix, Guardian can work for you.The core currency of authentication in Guardian is the token. By default JSON Web Tokens are supported out of the box but you can use any token that:Has the concept of a key-value payloadIs tamper proofCan serialize to a StringHas a supporting module that implements the Guardian.Token behaviourYou can use Guardian tokens to authenticate:Web endpoints (Plug/Phoenix/X)Channels/Sockets (Phoenix - optional)Any other system you can imagine. If you can attach an authentication token you can authenticate it.Tokens should be able to contain any assertions (claims) that a developer wants to make and may contain both standard and application specific information encoded within them.Guardian also allows you to configure multiple token types/configurations in a single application.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"API documentation is available at https://hexdocs.pm/guardian","ref":"readme.html#documentation","title":"Readme - Documentation","type":"extras"},{"doc":"Add Guardian to your application to your list of dependencies in mix.exs:defp deps do [ {:guardian, &quot;~&gt; 2.0&quot;} ] endIn order to leverage Guardian we'll need first create an &quot;implementation module&quot; which includes Guardian's functionality and the code for encoding and decoding our token's values. To do this, create a module that uses Guardian and implements the subject_for_token/2 and resource_from_claims/1 function.defmodule MyApp.Guardian do use Guardian, otp_app: :my_app def subject_for_token(%{id: id}, _claims) do # You can use any value for the subject of your token but # it should be useful in retrieving the resource later, see # how it being used on `resource_from_claims/1` function. # A unique `id` is a good subject, a non-unique email address # is a poor subject. sub = to_string(id) {:ok, sub} end def subject_for_token(_, _) do {:error, :reason_for_error} end def resource_from_claims(%{&quot;sub&quot; =&gt; id}) do # Here we&#39;ll look up our resource from the claims, the subject can be # found in the `&quot;sub&quot;` key. In above `subject_for_token/2` we returned # the resource id so here we&#39;ll rely on that to look it up. resource = MyApp.get_resource_by_id(id) {:ok, resource} end def resource_from_claims(_claims) do {:error, :reason_for_error} end endNext we need to add our configuration to config/config.exs:config :my_app, MyApp.Guardian, issuer: &quot;my_app&quot;, secret_key: &quot;Secret key. You can use `mix guardian.gen.secret` to get one&quot;Congrats! We have a working Guardian implementation.","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"# encode a token for a resource {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource) # decode and verify a token {:ok, claims} = MyApp.Guardian.decode_and_verify(token) # revoke a token (use GuardianDb or something similar if you need revoke to actually track a token) {:ok, claims} = MyApp.Guardian.revoke(token) # Refresh a token before it expires {:ok, _old_stuff, {new_token, new_claims}} = MyApp.Guardian.refresh(token) # Exchange a token of type &quot;refresh&quot; for a new token of type &quot;access&quot; {:ok, _old_stuff, {new_token, new_claims}} = MyApp.Guardian.exchange(token, &quot;refresh&quot;, &quot;access&quot;) # Lookup a resource directly from a token {:ok, resource, claims} = MyApp.Guardian.resource_from_token(token)With Plug:# If a session is loaded the token/resource/claims will be put into the session and connection # If no session is loaded, the token/resource/claims only go onto the connection conn = MyApp.Guardian.Plug.sign_in(conn, resource) # Optionally with claims and options conn = MyApp.Guardian.Plug.sign_in(conn, resource, %{some: &quot;claim&quot;}, ttl: {1, :minute}) # remove from session (if fetched) and revoke the token # can also clear the remember me token, if the option :clear_remember_me is set conn = MyApp.Guardian.Plug.sign_out(conn) # Set a &quot;refresh&quot; token directly on a cookie. # Can be used in conjunction with `Guardian.Plug.VerifyCookie` and `Guardian.Plug.SlidingCookie` conn = MyApp.Guardian.Plug.remember_me(conn, resource) # Fetch the information from the current connection token = MyApp.Guardian.Plug.current_token(conn) claims = MyApp.Guardian.Plug.current_claims(conn) resource = MyApp.Guardian.Plug.current_resource(conn)Creating with custom claims and options:# Add custom claims to a token {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource, %{some: &quot;claim&quot;}) # Create a specific token type (i.e. &quot;access&quot;/&quot;refresh&quot; etc) {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource, %{}, token_type: &quot;refresh&quot;) # Customize the time to live (ttl) of the token {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource, %{}, ttl: {1, :minute}) # Customize the secret {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource, %{}, secret: &quot;custom&quot;) {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource, %{}, secret: {SomeMod, :some_func, [&quot;some&quot;, &quot;args&quot;]}) # Require an &quot;auth_time&quot; claim to be added. {:ok, token, claims} = MyApp.Guardian.encode_and_sign(resource, %{}, auth_time: true)Decoding tokens:# Check some literal claims. (i.e. this is an access token) {:ok, claims} = MyApp.Guardian.decode_and_verify(token, %{&quot;typ&quot; =&gt; &quot;access&quot;}) # Use a custom secret {:ok, claims} = MyApp.Guardian.decode_and_verify(token, %{}, secret: &quot;custom&quot;) {:ok, claims} = MyApp.Guardian.decode_and_verify(token, %{}, secret: {SomeMod, :some_func, [&quot;some&quot;, &quot;args&quot;]}) # Specify a maximum age (since end user authentication time). If the token has an # `auth_time` claim and it is older than the `max_age` allows, the token will be invalid. {:ok, claims} = MyApp.Guardian.decode_and_verify(token, %{}, max_age: {2, :hours})If you need dynamic verification for JWT tokens, please see the documentation for Guardian.Token.Jwt and Guardian.Token.Jwt.SecretFetcher.","ref":"readme.html#basics","title":"Readme - Basics","type":"extras"},{"doc":"The following configuration is available to all implementation modules.token_module - The module that implements the functions for dealing with tokens. Default Guardian.Token.Jwt.Guardian can handle tokens of any type that implements the Guardian.Token behaviour. Each token module will have its own configuration requirements. Please see below for the JWT configuration.All configuration values may be provided in two ways.In your config filesAs a Keyword list to your call to use Guardian in your implementation module.Any options given to use Guardian have precedence over config values found in the config files.Some configuration may be required by your token_module.Configuration valuesGuardian supports resolving configuration options at runtime, to that we use the following syntax:{MyModule, :func, [:some, :args]} Calls the function on the module with argsThese are evaluated at runtime and any value that you fetch viaMyApp.Guardian.config(key, default) will be resolved using this scheme.See Guardian.Config.resolve_value/1 for more information.JWT (Configuration)The default token type of Guardian is JWT. It accepts many options but you really only need to specify the issuer and secret_key.Required configuration (JWT)issuer - The issuer of the token. Your application name/idsecret_key - The secret key to use for the implementation module. This may be any resolvable value for Guardian.Config.Optional configuration (JWT)token_verify_module - default Guardian.Token.Jwt.Verify. The module that verifies the claimsallowed_algos - The allowed algos to use for encoding and decoding. See JOSE for available. Default [&quot;HS512&quot;]ttl - The default time to live for all tokens. See the type in Guardian.ttltoken_ttl a map of token_type to ttl. Set specific ttls for specific types of tokensallowed_drift The drift that is allowed when decoding/verifying a token in millisecondsverify_issuer Default falsesecret_fetcher A module used to fetch the secret. Default: Guardian.Token.Jwt.SecretFetcherauth_time Include an auth_time claim to denote the end user authentication time. Default false.max_age Specify the maximum time (since the end user authentication) the token will be valid. Format is the same as ttl. Implies auth_time unless auth_time is set explicitly to false.See the OpenID Connect Core specification for more details about auth_time and max_age behaviour.","ref":"readme.html#configuration","title":"Readme - Configuration","type":"extras"},{"doc":"Secrets can be simple strings or more complicated JOSE secret schemes.The simplest way to use the JWT module is to provide a simple String. (mix guardian.gen.secret works great)Alternatively you can use a module and function by adding secret_key: {MyModule, :function_name, [:some, :args]}.More advanced secret information can be found below.","ref":"readme.html#secrets-jwt","title":"Readme - Secrets (JWT)","type":"extras"},{"doc":"Almost all of the functions provided by Guardian utilize options as the last argument. These options are passed from the initiating call through to the token_module and also your callbacks. See the documentation for your token_module (Guardian.Token.Jwt by default) for more information.","ref":"readme.html#using-options-in-calls","title":"Readme - Using options in calls","type":"extras"},{"doc":"Each implementation module (modules that use Guardian) implement callbacks for the Guardian behaviour. By default, these are just pass-through but you can implement your own version to tweak the behaviour of your tokens.The callbacks are:after_encode_and_signafter_sign_inbefore_sign_outbuild_claims - Use this to tweak the claims that you include in your tokendefault_token_type - default is &quot;access&quot;on_exchangeon_revokeon_refreshon_verifyverify_claims - You can add custom validations for your tokens in this callback","ref":"readme.html#hooks","title":"Readme - Hooks","type":"extras"},{"doc":"Guardian provides various plugs to help work with web requests in Elixir. Guardian's plugs are optional and will not be compiled if you're not using Plug in your application.All plugs need to be in a pipeline. A pipeline is just a way to get the implementation module and error handler into the connection for use downstream. More information can be found in the Pipelines section.Plugs and keys (advanced usage)All Plugs and related functions provided by Guardian have the concept of a key. A key specifies a label that is used to keep tokens separate so that you can have multiple token/resource/claims active in a single request.In your plug pipeline you may use something like:plug Guardian.Plug.VerifyHeader, key: :impersonate plug Guardian.Plug.EnsureAuthenticated, key: :impersonateIn your action handler:resource = MyApp.Guardian.Plug.current_resource(conn, key: :impersonate) claims = MyApp.Guardian.Plug.current_claims(conn, key: :impersonate)Plugs out of the boxGuardian.Plug.VerifyHeaderLook for a token in the header and verify itGuardian.Plug.VerifySessionLook for a token in the session and verify itGuardian.Plug.VerifyCookieNOTE: this plug is deprecated. Please use :refresh_from_cookie option in Guardian.Plug.VerifyHeader or Guardian.Plug.VerifySessionLook for a token in cookies and exchange it for an access tokenGuardian.Plug.SlidingCookieReplace the token in cookies with a new one when a configured minimum TTL is remaining.Guardian.Plug.EnsureAuthenticatedMake sure that a token was found and is validGuardian.Plug.EnsureNotAuthenticatedMake sure no one is logged inGuardian.Plug.LoadResourceIf a token was found, load the resource for itSee the documentation for each Plug for more information.PipelinesA pipeline is a way to collect together the various plugs for a particular authentication scheme.Apart from keeping an authentication flow together, pipelines provide downstream information for error handling and which implementation module to use. You can provide this separately but we recommend creating a pipeline plug.Create a custom pipelinedefmodule MyApp.AuthAccessPipeline do use Guardian.Plug.Pipeline, otp_app: :my_app plug Guardian.Plug.VerifySession, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.VerifyHeader, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.EnsureAuthenticated plug Guardian.Plug.LoadResource, allow_blank: true endBy default, the LoadResource plug will return an error if no resource can be found. You can override this behaviour using the allow_blank: true option.Add your implementation module and error handler to your configuration:config :my_app, MyApp.AuthAccessPipeline, module: MyApp.Guardian, error_handler: MyApp.AuthErrorHandlerBy using a pipeline, apart from keeping your auth logic together, you're instructing downstream plugs to use a particular implementation module and error handler.If you wanted to do that manually:plug Guardian.Plug.Pipeline, module: MyApp.Guardian, error_handler: MyApp.AuthErrorHandler plug Guardian.Plug.VerifySessionPlug Error HandlersThe error handler is a module that implements an auth_error function:defmodule MyApp.AuthErrorHandler do import Plug.Conn @behaviour Guardian.Plug.ErrorHandler @impl Guardian.Plug.ErrorHandler def auth_error(conn, {type, _reason}, _opts) do body = Jason.encode!(%{message: to_string(type)}) conn |&gt; put_resp_content_type(&quot;application/json&quot;) |&gt; send_resp(401, body) end endPhoenixGuardian and Phoenix are perfect together, but to get the most out of the integration be sure to include the guardian_phoenix library.See the Guardian Phoenix documentation for more information.","ref":"readme.html#plugs","title":"Readme - Plugs","type":"extras"},{"doc":"Permissions can be encoded into your token as an optional add-in.Encoding permissions into a token is useful in some areas of authorization. The permissions provided by Guardian.Permissions have one level of nesting.For example:users -&gt; profile_readusers -&gt; profile_writeusers -&gt; followers_readusers -&gt; followers_writeadmin -&gt; all_users_readadmin -&gt; all_users_writeOnce a permission is granted it is valid for as long as the token is valid. Since the permission is valid for the life of a token it is not suitable to encode highly dynamic information into a token. These permissions are similar in intent to OAuth scopes. Very useful as a broad grant to an area of code for 3rd party services / other microservices. If you have a requirement to look up permissions from your database for a particular user on each request, these are not the permissions you're looking for.Please see Guardian.Permissions for more information.","ref":"readme.html#permissions","title":"Readme - Permissions","type":"extras"},{"doc":"When using tokens, depending on the type of token you use, nothing may happen by default when you revoke a token.For example, JWT tokens by default are not tracked by the application. The fact that they are signed with the correct secret and are not expired is usually how validation of if a token is active or not. Depending on your use-case this may not be enough for your application needs. If you need to track and revoke individual tokens, you may need to use something like GuardianDb.This will record each token issued in your database, confirm it is still valid on each access and then finally when you revoke (called on sign_out or manually) invalidate the token.For more in-depth documentation please see the GuardianDb README.","ref":"readme.html#tracking-tokens","title":"Readme - Tracking Tokens","type":"extras"},{"doc":"How to add the token to a request (the Phoenix way)Assuming you are using the default authentication scheme Bearer for the Authorization header:defmodule HelloWeb.AuthControllerTest do use HelloWeb.ConnCase import HelloWeb.Guardian test &quot;GET /auth/me&quot;, %{conn: conn} do user = insert(:user) # See https://github.com/thoughtbot/ex_machina {:ok, token, _} = encode_and_sign(user, %{}, token_type: :access) conn = conn |&gt; put_req_header(&quot;authorization&quot;, &quot;Bearer &quot; &lt;&gt; token) |&gt; get(auth_path(conn, :me)) # Assert things here end end","ref":"readme.html#best-testing-practices","title":"Readme - Best testing practices","type":"extras"},{"doc":"GuardianDb - Token tracking in the databaseGuardianPhoenix - Phoenix integrationsans_password - A simple, passwordless authentication system based on Guardian.protego - Flexible authentication solution for Elixir/Phoenix with Guardian.","ref":"readme.html#related-projects","title":"Readme - Related projects","type":"extras"},{"doc":"By specifying a binary, the default behavior is to treat the key as an &quot;oct&quot; key type (short for octet sequence). This key type may be used with the &quot;HS256&quot;, &quot;HS384&quot;, and &quot;HS512&quot; signature algorithms.Alternatively, a configuration value that resolves to:MapFunction%JOSE.JWK{} StructMay be specified for other key types. A full list of example key types is available here.See the key generation docs from Jose for how to generate your own keys.To get off the ground quickly, set your secret_key in your Guardian config with the output of either:$ mix guardian.gen.secret`oriex&gt; JOSE.JWS.generate_key(%{&quot;alg&quot; =&gt; &quot;HS512&quot;}) |&gt; JOSE.JWK.to_map |&gt; elem(1) |&gt; Map.take([&quot;k&quot;, &quot;kty&quot;])After running $ mix deps.get because JOSE is one of Guardian's dependencies:## Map ## config :my_app, MyApp.Guardian, allowed_algos: [&quot;ES512&quot;], secret_key: %{ &quot;crv&quot; =&gt; &quot;P-521&quot;, &quot;d&quot; =&gt; &quot;axDuTtGavPjnhlfnYAwkHa4qyfz2fdseppXEzmKpQyY0xd3bGpYLEF4ognDpRJm5IRaM31Id2NfEtDFw4iTbDSE&quot;, &quot;kty&quot; =&gt; &quot;EC&quot;, &quot;x&quot; =&gt; &quot;AL0H8OvP5NuboUoj8Pb3zpBcDyEJN907wMxrCy7H2062i3IRPF5NQ546jIJU3uQX5KN2QB_Cq6R_SUqyVZSNpIfC&quot;, &quot;y&quot; =&gt; &quot;ALdxLuo6oKLoQ-xLSkShv_TA0di97I9V92sg1MKFava5hKGST1EKiVQnZMrN3HO8LtLT78SNTgwJSQHAXIUaA-lV&quot; } ## Tuple ## # If, for example, you have your secret key stored externally (in this example, we&#39;re using Redix). # defined elsewhere defmodule MySecretKey do def fetch do # Bad practice for example purposes only. # An already established connection should be used and possibly cache the value locally. {:ok, conn} = Redix.start_link rsa_jwk = conn |&gt; Redix.command!([&quot;GET my-rsa-key&quot;]) |&gt; JOSE.JWK.from_binary Redix.stop(conn) rsa_jwk end end config :my_app, MyApp.Guardian, allowed_algos: [&quot;RS512&quot;], secret_key: {MySecretKey, :fetch, []} ## %JOSE.JWK{} Struct ## # Useful if you store your secret key in an encrypted JSON file with the passphrase in an environment variable. # defined elsewhere defmodule MySecretKey do def fetch do System.get_env(&quot;SECRET_KEY_PASSPHRASE&quot;) |&gt; JOSE.JWK.from_file(System.get_env(&quot;SECRET_KEY_FILE&quot;)) end end config :my_app, MyApp.Guardian, allowed_algos: [&quot;Ed25519&quot;], secret_key: {MySecretKey, :fetch, []}Private/Public Key pairsA full example of how to configure guardian to use private/public key files as secrets, can be found here.Key RotationGuardian provides a Guardian.Token.Jwt.SecretFetcher behaviour that allows custom keys to be used for signing and verifying requests. This makes it possible to rotate private keys while maintaining a list of valid public keys that can be used both for validating signatures as well as serving public keys to external services.Below is a simple example of how this can be implemented using a GenServer.defmodule MyApp.Guardian.KeyServer do @moduledoc ~S&quot;&quot;&quot; A simple GenServer implementation of a custom `Guardian.Token.Jwt.SecretFetcher` This is appropriate for development but should not be used in production due to questionable private key storage, lack of multi-node support, node restart durability, and public key garbage collection. &quot;&quot;&quot; use GenServer @behaviour Guardian.Token.Jwt.SecretFetcher @impl Guardian.Token.Jwt.SecretFetcher # This will always return a valid key as a new one will be generated # if it does not already exist. def fetch_signing_secret(_mod, _opts), do: {:ok, GenServer.call(__MODULE__, :fetch_private_key)} @impl Guardian.Token.Jwt.SecretFetcher # This assumes that the adapter properly assigned a key id (kid) # to the signing key. Make sure it&#39;s there! with something like # JOSE.JWK.merge(jwk, %{&quot;kid&quot; =&gt; JOSE.JWK.thumbprint(jwk)}) # see https://tools.ietf.org/html/rfc7515#section-4.1.4 # for details def fetch_verifying_secret(_mod, %{&quot;kid&quot; =&gt; kid}, _opts) do case GenServer.call(__MODULE__, {:fetch_public_key, kid}) do {:ok, public_key} -&gt; {:ok, public_key} :error -&gt; {:error, :secret_not_found} end end def fetch_verifying_secret(_, _, _), do: {:error, :secret_not_found} # This is not a defined callback for the SecretFetcher, but could be useful # for providing an endpoint that external services could use to verify tokens # for themselves. def fetch_verifying_secrets, do: GenServer.call(__MODULE__, :fetch_public_keys) # Expire the private key so that a new one will be generated on the next # signing request. The public key associated with the old private key should # be stored at the very least as long as the largest possible &quot;exp&quot; # (https://tools.ietf.org/html/rfc7519#section-4.1.4) value for any token # signed by the old private key before this method was called. def expire_private_key, do: GenServer.cast(__MODULE__, :expire_private_key) # Generate a new key pair along with the key ID (kid) @spec generate_keypair() :: {:ok, JOSE.JWK.t(), JOSE.JWK.t(), String.t()} def generate_keypair() do # Choose an appropriate signing algorithm for your security needs. private_key = JOSE.JWK.generate_key({:okp, :Ed25519}) # Generate a kid by using the key&#39;s thumbprint # https://tools.ietf.org/html/draft-ietf-jose-jwk-thumbprint-08#section-1 kid = JOSE.JWK.thumbprint(private_key) # Update the private key to contain the &quot;kid&quot; private_key = JOSE.JWK.merge(private_key, %{&quot;kid&quot; =&gt; kid}) # Create a public key based on the private key. It will carry the same &quot;kid&quot; public_key = JOSE.JWK.to_public(private_key) {:ok, private_key, public_key, kid} end def start_link(_opts) do GenServer.start_link(__MODULE__, :ok, name: __MODULE__) end def init(_opts) do {:ok, %{private_key: nil, public_keys: %{}}} end # Callbacks def handle_cast(:expire_private_key, state), do: {:noreply, %{state | private_key: nil}} # Generate a new signing key if one does not already exist def handle_call(:fetch_private_key, _from, %{private_key: nil, public_keys: key_list}) do {:ok, private_key, public_key, kid} = generate_keypair() {:reply, private_key, %{ private_key: private_key, public_keys: Map.put(key_list, kid, public_key) }} end def handle_call(:fetch_private_key, _from, %{private_key: private_key} = state), do: {:reply, private_key, state} def handle_call({:fetch_public_key, kid}, _from, %{public_keys: public_keys} = state), do: {:reply, Map.fetch(public_keys, kid), state} def handle_call(:fetch_public_keys, _from, %{public_keys: public_keys} = state), do: {:reply, Map.values(public_keys), state} endUpdate Guardian's configuration to use the custom KeyServer:## config/config.exs config :my_app, MyApp.Guardian, issuer: &quot;myapp&quot;, allowed_algos: [&quot;Ed25519&quot;], secret_fetcher: MyApp.Guardian.KeyServerStart the KeyServer in the supervision tree so it can serve requests:## lib/my_app/application.ex def start(_type, _args) do # List all child processes to be supervised children = [ MyAppWeb.Endpoint, MyApp.Guardian.KeyServer ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end","ref":"readme.html#more-advanced-secrets","title":"Readme - More advanced secrets","type":"extras"},{"doc":"Copyright (c) 2015 Daniel NeighmanThis library is MIT licensed. See the LICENSE for details.","ref":"readme.html#copyright-and-license","title":"Readme - Copyright and License","type":"extras"},{"doc":"OverviewGuardian is the authentication toolkit for Elixir. It provides token based authentication. It does not provide implementations for the challenge phase (the first verification of the resource/user) built to suit Elixir idioms.To perform the challenge phase of authentication you can use Ueberauth to help you or use whatever methodology makes sense for your application.","ref":"introduction-overview.html","title":"Overview","type":"extras"},{"doc":"The default token type for Guardian is JWT. This is not fixed. Guardian can use any token that conforms to the Guardian.Token behaviour.JWT is a reasonable default that can be used in most situations including browser, mobile, 3rd party services over any communication channel. If you can get a token to your application, Guardian can use it.","ref":"introduction-overview.html#defaults","title":"Overview - Defaults","type":"extras"},{"doc":"Guardian's functionality has two core pieces.Creating TokensVerifying tokensIt also providesCustom TokensPlug integrationPhoenix integrationPermissions","ref":"introduction-overview.html#guardian","title":"Overview - Guardian","type":"extras"},{"doc":"Guardian provides behaviours so that different implementations can be created.For example you could have two token types for different purposes both backed by the default (JWT).defmodule MyApp.TokenModuleOne do use Guardian, otp_app: :my_app # ... end defmodule MyApp.TokenModuleTwo do use Guardian, otp_app: :my_app # ... endBy allowing different modules to be implemented you can have multiple configurations inside your application for different purposes.Token implementations are provided via an adapter pattern. By implementing the Guardian.Token behaviour your backend can be implemented any way you need, and specified in your configuration via the token_module option as either an option to the use call or in your configuration.defmodule MyApp.TokenModuleCustom do use Guardian, otp_app: :my_app, token_module: MyApp.CustomTokenBackend # ... endor via configurationdefmodule MyApp.TokenModuleCustom do use Guardian, otp_app: :my_app # ... enduse Mix.Config config :my_app, MyApp.TokenModuleCustom, token_module: MyApp.CustomTokenBackendAll configuration for your implementation module can be done this way - either via arguments to use or inside configuration.Check the implementation module docs for more information.TutorialsGetting started","ref":"introduction-overview.html#tokens-in-your-application","title":"Overview - Tokens in your application","type":"extras"},{"doc":"To contribute to the guides, please submit a pull request to the guardian project on GitHub.You'll find the content under guides/.","ref":"introduction-overview.html#guides","title":"Overview - Guides","type":"extras"},{"doc":"InstallationTo install Guardian, add an entry to your mix.exs:def deps do [ # ... {:guardian, &quot;~&gt; 1.0&quot;} ] end","ref":"introduction-installation.html","title":"Installation","type":"extras"},{"doc":"Guardian requires knowing some information for how you want your token to behave.By default, Guardian uses JWT as the default token type but other token types can be used by implementing the Guardian.Token behaviour.","ref":"introduction-installation.html#implementation-module","title":"Installation - Implementation Module","type":"extras"},{"doc":"Configuration for Guardian is determined by the Token module that is used and may be extended by other modules.For default setup please see the default token docs","ref":"introduction-installation.html#configuration","title":"Installation - Configuration","type":"extras"},{"doc":"Most people use Guardian to support HTTP and Websockets with Phoenix.Phoenix and Plug are not required but if they are present Most people use Absinthe to support an HTTP API.You'll want to read the Plug and Phoenix for specific installation and configuration options.","ref":"introduction-installation.html#plug-phoenix-and-guardian","title":"Installation - Plug, Phoenix, and Guardian","type":"extras"},{"doc":"Implementation ModulesImplementation modules are the heart of how you interact with Guardian in your application. Almost all functions for using Guardian are done via your implementation module.They encapsulate the configuration and behaviour that you specify and utilize a token backend to implement the details of the type of token you've chosen (default JWT).Previous versions of Guardian used the Guardian module directly which was very limiting. This limitation forced only a single type of token could be used for your entire application and made customization difficult, verbose and somewhat confusing.","ref":"introduction-implementation.html","title":"Implementation Modules","type":"extras"},{"doc":"Guardian is used to encode and decode tamper proof tokens for the purpose of authentication. For integrations see the plug guide and/or the Phoenix guide. If you're using Plug or Phoenix you probably won't need to drop down to this level but from time to time it's useful.BasicsThe main functions that are useful for encoding and decoding tokens are:# create tokens {:ok, token, full_claims} = MyApp.TokenImpl.encode_and_sign(user) # decoding tokens {:ok, claims} = MyApp.TokenImpl.decode_and_verify(token_string) # decoding token and fetching resource in one step {:ok, user, claims} = MyApp.TokenImpl.resource_from_token(token_string)When creating tokens, you can add custom claims to your tokens. The resulting token will be a merge (in order of application) of:the claims provided by your tokenthe claims you pass inany changes you make in your Guardian.build_claims callbackFor example:{:ok, token, full_claims} = MyApp.TokenImpl.encode_and_sign(user, %{some: &quot;data to store&quot;})","ref":"introduction-implementation.html#usage","title":"Implementation Modules - Usage","type":"extras"},{"doc":"The most basic setup for an implementation module consists of use Guardian passing the atom of your otp app. See JWT implementation for specific information about setting up for JWT.defmodule MyApp.TokenImpl do use Guardian, otp_app: :my_app def subject_for_token(resource, options) do {:ok, resource.id} end def resource_from_claims(claims) do # find user from claims[&quot;sub&quot;] or other information you stored inside claims end endThis setup will use your configuration and the default options. If you want to change your token backend, you can use the :token_module option in your configuration.The functions subject_for_token and resource_from_claims are the only two functions that must be implemented. They are effectively opposites of one another.subject_for_token - provide the identifier to be encoded into your token that you will use in resource_from_claims to lookup the resourceresource_from_claims - using the identifier provided by subject_for_token find the associated resourceAll other callbacks have a default noop in their implementations and are optional.subject_for_token provides the sub field (in JWT parlance) which identifies the subject which is usually the resource to use. The subject field can be anything that helps you identify which resource is logged in. Some examples:&quot;User:420&quot;&quot;420&quot;&quot;u|420&quot;Some thought about what this is can be useful. If you have more than one type of struct that you want to be able to authenticate prefixing with some type of struct identifier is helpful to switch (prefix can be pattern matched, suffix cannot). Once your token is out in the wild, you will need to support all of those subject schemes until the last issued token expires or is revoked. An example of pattern matching via a prefix:def subject_for_token(%User{uid: uid} = user, _claims) do {:ok, &quot;User:\#{uid}&quot;} end def subject_for_token(_, _), do: {:error, :unhandled_resource_type} def resource_from_claims(%{&quot;sub&quot; =&gt; &quot;User:&quot; &lt;&gt; uid}) do case Repo.get_by(User, %{uid: uid}) do nil -&gt; {:error, :user_not_found} user -&gt; {:ok, user} end end def resource_from_claims(_), do: {:error, :unhandled_resource_type}","ref":"introduction-implementation.html#basic-setup","title":"Implementation Modules - Basic Setup","type":"extras"},{"doc":"Configuration for your implementation module can be done either in your configuration files using the same otp_app identifier as your call to use Guardian. Alternatively you can provide options to the use Guardian call to put your configuration there. Configuration provided in your implementation module takes precedence over anything found in the configuration files. You can also put some parts in your config and some in your configuration files to account for different environments.","ref":"introduction-implementation.html#configuration","title":"Implementation Modules - Configuration","type":"extras"},{"doc":"Guardian provides callbacks to allow you to hook into different parts of the authentication lifecycle. These callbacks can be used for any purpose and are used by the GuardianDB package.The most common callbacks to use are:build_claimsverify_claimsUsing the build_claims callback you can modify the structure of the claims any way you need to. You can add, change or remove any key/value pairs added by your token module.Using the verify_claims callback you can implement any custom validation you require on your tokens.There are other callbacks available.","ref":"introduction-implementation.html#callbacks","title":"Implementation Modules - Callbacks","type":"extras"},{"doc":"Community","ref":"introduction-community.html","title":"Community","type":"extras"},{"doc":"You can find the maintainers and an active community of users and contributors in the #ueberauth channel in the Elixir Slack.","ref":"introduction-community.html#chat","title":"Community - Chat","type":"extras"},{"doc":"Questions and suggestions can be submitted on the Elixir Forum. Please categorize/tag as Guardian.","ref":"introduction-community.html#forum","title":"Community - Forum","type":"extras"},{"doc":"Getting Started with GuardianGetting started with Guardian is easy. This tutorial will coverSetting up the basics of GuardianHTTP integrationLogin/LogoutThis tutorial was based on this article by Tyler Pachal.We'll use Phoenix for this tutorial since most folks will be using it. There is no requirement to use Phoenix with Guardian but it makes this tutorial easier.We'll also use the default token type of JWT. You don't have to use JWT for your token backend. See the token documentation for more information.Authentication consists of a challenge phase (prove who you are) and then followed by a verification phase (has this actor proven who they are?). Guardian looks after the second part for you. It's up to your application to implement the challenge phase after which Guardian will do the rest. In this tutorial we'll use comeonin with argon2 for the challenge phase.Let's generate an application.$ mix phx.new auth_me","ref":"tutorial-start.html","title":"Getting Started with Guardian","type":"extras"},{"doc":"You'll need to update the dependencies to whatever is latest.## mix.exs defp deps do [ {:guardian, &quot;~&gt; 2.0&quot;}, {:argon2_elixir, &quot;~&gt; 2.0&quot;}, ] end","ref":"tutorial-start.html#specify-your-dependencies","title":"Getting Started with Guardian - Specify your dependencies","type":"extras"},{"doc":"We'll need something to authenticate. How Users are created and what they can do is outside the scope of this tutorial. If you already have a User model you can skip this part (but see the note after the command).$ mix phx.gen.context UserManager User users username:string password:stringNote: if you already have a User model, you need to implement some of the functions generated by phx.gen.context, which are:def list_users do Repo.all(User) end def get_user!(id), do: Repo.get!(User, id) #The tutorial calls this one: def create_user(attrs \\\\ %{}) do %User{} |&gt; User.changeset(attrs) |&gt; Repo.insert() end def update_user(%User{} = user, attrs) do user |&gt; User.changeset(attrs) |&gt; Repo.update() end def delete_user(%User{} = user) do Repo.delete(user) end #The tutorial calls this one: def change_user(%User{} = user) do User.changeset(user, %{}) end","ref":"tutorial-start.html#create-a-user-manager","title":"Getting Started with Guardian - Create a user manager","type":"extras"},{"doc":"Guardian needs an implementation. This implementation module encapsulates:Token typeConfigurationEncoding/DecodingCallbacksFor more information please reference the implementation module docs.You can have as many implementation modules as you need to depending on your application. For this one though we only have a simple user system so we'll only need one.## lib/auth_me/user_manager/guardian.ex defmodule AuthMe.UserManager.Guardian do use Guardian, otp_app: :auth_me alias AuthMe.UserManager def subject_for_token(user, _claims) do {:ok, to_string(user.id)} end def resource_from_claims(%{&quot;sub&quot; =&gt; id}) do user = UserManager.get_user!(id) {:ok, user} rescue Ecto.NoResultsError -&gt; {:error, :resource_not_found} end endsubject_for_token and resource_from_claims are inverses of one another. subject_for_token is used to encode the User into the token, and resource_from_claims is used to rehydrate the User from the claims.There are many other callbacks that you can use, but we're going basic.","ref":"tutorial-start.html#create-implementation-module","title":"Getting Started with Guardian - Create implementation module","type":"extras"},{"doc":"To use the JWT token type, we'll need a secret. We'll use the HS512 algorithm which is a simple hashing algorithm. The most basic configuration is very straight forward.The secret can be any string but it's recommended that you use the generator provided with Guardian for this.$ mix guardian.gen.secretCopy the output from the previous command and add it to your configuration.## config.exs config :auth_me, AuthMe.UserManager.Guardian, issuer: &quot;auth_me&quot;, secret_key: &quot;&quot; # put the result of the mix command above hereYou should change the secret key for each environment and manage them with your secret management strategy.","ref":"tutorial-start.html#setup-guardian-config","title":"Getting Started with Guardian - Setup Guardian config","type":"extras"},{"doc":"This too is not strictly required for Guardian. If you already have a way for you to verify user/password for your user model you can skip this part.We'll implement a simple version of password hashing for this tutorial. This is up to your application and is only shown here for example purposes.We added :comeonin and :argon2_elixir to our mix deps at the start. We're going to use them in two places.When setting the password for the userWhen verifying the login credentials## lib/auth_me/user_manager/user.ex alias Argon2 def changeset(user, attrs) do user |&gt; cast(attrs, [:username, :password]) |&gt; validate_required([:username, :password]) |&gt; put_password_hash() end defp put_password_hash(%Ecto.Changeset{valid?: true, changes: %{password: password}} = changeset) do change(changeset, password: Argon2.hash_pwd_salt(password)) end defp put_password_hash(changeset), do: changesetNow we need a way to verify the username/password credentials.## lib/auth_me/user_manager.ex alias Argon2 import Ecto.Query, only: [from: 2] def authenticate_user(username, plain_text_password) do query = from u in User, where: u.username == ^username case Repo.one(query) do nil -&gt; Argon2.no_user_verify() {:error, :invalid_credentials} user -&gt; if Argon2.verify_pass(plain_text_password, user.password) do {:ok, user} else {:error, :invalid_credentials} end end endAt this point, the autogenerated tests when we first created the UserManager and User (if you followed this guide to the letter) would fail when you run mix test. This is due to the fact that the autogenerated tests don't know about passwords - all it knows is your Users table has two string columns that it needs to check.Fixing the broken tests is simple: we want to compare the encrypted passwords instead of plain text ones.## test/auth_me/user_manager_test.exs ... test &quot;create_user/1 with valid data creates a user&quot; do assert {:ok, %User{} = user} = UserManager.create_user(@valid_attrs) assert {:ok, user} == Argon2.check_pass(user, &quot;some password&quot;, hash_key: :password) assert user.username == &quot;some username&quot; end ... test &quot;update_user/2 with valid data updates the user&quot; do user = user_fixture() assert {:ok, %User{} = user} = UserManager.update_user(user, @update_attrs) assert {:ok, user} == Argon2.check_pass(user, &quot;some updated password&quot;, hash_key: :password) assert user.username == &quot;some updated username&quot; end ...That's it for Guardian setup. We had some User setup in there too that was unrelated but if you don't have a user model it will help you get started.The next step is getting it into your application via HTTP.","ref":"tutorial-start.html#password-hashing","title":"Getting Started with Guardian - Password hashing","type":"extras"},{"doc":"For HTTP Guardian makes use of the Plug architecture and uses it to construct pipelines. The pipeline provides downstream plugs with the implementation module and the error handler that the Guardian plugs require to do their job.Please read the pipeline guide for more information.We want our pipeline to look after session and header authentication (where to look for the token), load the User but not enforce it. By not enforcing it we can have a &quot;logged in&quot; or &quot;maybe logged in&quot;. We can use the Guardian.Plug.EnsureAuthenticated plug for those cases where we must have a logged in User by using Phoenix pipelines in the router.## lib/auth_me/user_manager/pipeline.ex defmodule AuthMe.UserManager.Pipeline do use Guardian.Plug.Pipeline, otp_app: :auth_me, error_handler: AuthMe.UserManager.ErrorHandler, module: AuthMe.UserManager.Guardian # If there is a session token, restrict it to an access token and validate it plug Guardian.Plug.VerifySession, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} # If there is an authorization header, restrict it to an access token and validate it plug Guardian.Plug.VerifyHeader, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} # Load the user if either of the verifications worked plug Guardian.Plug.LoadResource, allow_blank: true endWe'll also need the error handler referenced in our pipeline to handle the case where there was a failure to authenticate.## lib/auth_me/user_manager/error_handler.ex defmodule AuthMe.UserManager.ErrorHandler do import Plug.Conn @behaviour Guardian.Plug.ErrorHandler @impl Guardian.Plug.ErrorHandler def auth_error(conn, {type, _reason}, _opts) do body = to_string(type) conn |&gt; put_resp_content_type(&quot;text/plain&quot;) |&gt; send_resp(401, body) end end","ref":"tutorial-start.html#pipelines","title":"Getting Started with Guardian - Pipelines","type":"extras"},{"doc":"This pipeline is now ready for us to use. Now we need some way to login/logout the user and some resource to protect. For this we'll create a sessions controller, and use the PageController for our protected resource## lib/auth_me_web/controllers/session_controller.ex defmodule AuthMeWeb.SessionController do use AuthMeWeb, :controller alias AuthMe.{UserManager, UserManager.User, UserManager.Guardian} def new(conn, _) do changeset = UserManager.change_user(%User{}) maybe_user = Guardian.Plug.current_resource(conn) if maybe_user do redirect(conn, to: &quot;/protected&quot;) else render(conn, &quot;new.html&quot;, changeset: changeset, action: Routes.session_path(conn, :login)) end end def login(conn, %{&quot;user&quot; =&gt; %{&quot;username&quot; =&gt; username, &quot;password&quot; =&gt; password}}) do UserManager.authenticate_user(username, password) |&gt; login_reply(conn) end def logout(conn, _) do conn |&gt; Guardian.Plug.sign_out() #This module&#39;s full name is Auth.UserManager.Guardian.Plug, |&gt; redirect(to: &quot;/login&quot;) #and the arguments specified in the Guardian.Plug.sign_out() end #docs are not applicable here defp login_reply({:ok, user}, conn) do conn |&gt; put_flash(:info, &quot;Welcome back!&quot;) |&gt; Guardian.Plug.sign_in(user) #This module&#39;s full name is Auth.UserManager.Guardian.Plug, |&gt; redirect(to: &quot;/protected&quot;) #and the arguments specified in the Guardian.Plug.sign_in() end #docs are not applicable here. defp login_reply({:error, reason}, conn) do conn |&gt; put_flash(:error, to_string(reason)) |&gt; new(%{}) end endCreate a session view## lib/auth_me_web/views/session_view.ex defmodule AuthMeWeb.SessionView do use AuthMeWeb, :view endAnd for the login template and secret template:## lib/auth_ex_web/templates/session/new.html.eex &lt;h2&gt;Login Page&lt;/h2&gt; &lt;%= form_for @changeset, @action, fn f -&gt; %&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= label f, :username, class: &quot;control-label&quot; %&gt; &lt;%= text_input f, :username, class: &quot;form-control&quot; %&gt; &lt;%= error_tag f, :username %&gt; &lt;/div&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= label f, :password, class: &quot;control-label&quot; %&gt; &lt;%= password_input f, :password, class: &quot;form-control&quot; %&gt; &lt;%= error_tag f, :password %&gt; &lt;/div&gt; &lt;div class=&quot;form-group&quot;&gt; &lt;%= submit &quot;Submit&quot;, class: &quot;btn btn-primary&quot; %&gt; &lt;/div&gt; &lt;% end %&gt;Lets make the protected resource implementation.## lib/auth_me_web/controllers/page_controller.ex defmodule AuthMeWeb.PageController do use AuthMeWeb, :controller def protected(conn, _) do user = Guardian.Plug.current_resource(conn) render(conn, &quot;protected.html&quot;, current_user: user) end def index(conn, _params) do render(conn, &quot;index.html&quot;) end endWe use the Guardian.Plug.current_resource(conn) function here to fetch the User. You must load this first using the Guardian.Plug.LoadResource plug which we included in our auth pipeline earlier.## lib/auth_me_web/templates/page/protected.html.eex &lt;h2&gt;Protected Page&lt;/h2&gt; &lt;p&gt;You can only see this page if you are logged in&lt;/p&gt; &lt;p&gt;You&#39;re logged in as &lt;%= @current_user.username %&gt;&lt;/p&gt;","ref":"tutorial-start.html#controller","title":"Getting Started with Guardian - Controller","type":"extras"},{"doc":"Okay. So the controller and views are not strictly part of Guardian but we need some way to interact with it. From here the only thing left for us to do is to wire up our router.# Our pipeline implements &quot;maybe&quot; authenticated. We&#39;ll use the `:ensure_auth` below for when we need to make sure someone is logged in. pipeline :auth do plug AuthMe.UserManager.Pipeline end # We use ensure_auth to fail if there is no one logged in pipeline :ensure_auth do plug Guardian.Plug.EnsureAuthenticated end # Maybe logged in routes scope &quot;/&quot;, AuthMeWeb do pipe_through [:browser, :auth] get &quot;/&quot;, PageController, :index get &quot;/login&quot;, SessionController, :new post &quot;/login&quot;, SessionController, :login get &quot;/logout&quot;, SessionController, :logout end # Definitely logged in scope scope &quot;/&quot;, AuthMeWeb do pipe_through [:browser, :auth, :ensure_auth] get &quot;/protected&quot;, PageController, :protected endThere's a little bit happening here.We created a Phoenix pipeline that just delegates to our Guardian pipeline to login someone if we find a token in the session or header. This does not restrict access.We restrict access using both our :auth and :ensure_auth phoenix pipelines and use that to protect our protected route.Note that you must use the :auth pipeline before the :ensure_auth one to make sure that we have fetched and verified the token. We're also loading the User but that is not required for ensure auth.","ref":"tutorial-start.html#routes","title":"Getting Started with Guardian - Routes","type":"extras"},{"doc":"Migrate your users table.$ mix ecto.migrateSince we didn't implement a form for creating a user we'll need to do that from the command line. Open up iex$ iex -S mixCreate the user:iex(1)&gt; AuthMe.UserManager.create_user(%{username: &quot;me&quot;, password: &quot;secret&quot;})Now exit iex and start up your server:$ mix phx.serverEnter localhost:4000/protected in your browser's address bar, and you should see &quot;unauthenticated&quot;. Now, enter localhost:4000/login in your browser's address bar, and login with your me username and secret password. You should automatically be redirected to the protected page, which you can now see! To logout, enter localhost:4000/logout in your browser's address bar, and you will be redirected to the login page. Instead of logging in, enter localhost:4000/protected in your browser's address bar, and you will see &quot;unauthenticated&quot; again!","ref":"tutorial-start.html#try-it-out","title":"Getting Started with Guardian - Try it out","type":"extras"},{"doc":"TokensGuardian uses the concept of a token as a currency of authentication credentials.Tokens can be anything that has the following properties:tamper proof (signed/encrypted verifiable by the application)include a payload (claims)Claims should be a map using string keys.JWT tokens (the default) fit these requirements and are widely supported in most languages using either hashed or cert based signing algorithms. However this is only one option. You can provide other behaviours like revocation, db tracking or another standard token type.Tokens can be provided by any means, they can be put into HTTP request headers, cookies, sessions; really as long as you can get your token to your application you can verify it and use it.Configuration of your token comes from two places:token module - the token module that you're using provides some default optionsImplementation module - you can provide custom options in your implementation module (the module that implements Guardian for your application).","ref":"tokens-start.html","title":"Start","type":"extras"},{"doc":"JWT TokensThe default implementation of a Token in Guardian is JWT.The default payload of a JWT token produced by Guardian contains the following:iss (Issuer): Identifies principal that issued the JWT. This normally comes from your application config, e.g. config :idp, Idp.Auth.Guardian, issuer: &quot;idp&quot;.sub (Subject): Identifies the subject. Identifies the subject of the JWT, e.g. User:123.aud (Audience): Identifies the recipients that the JWT is intended for. By default it is the same as iss.exp (Expiration Time): Identifies the expiration time on and after which the token will become invalid. It is represented as a unix timestamp. The expiration time is set via the option exp. By default it's 4 weeks in Guardian.iat (Issued at): Identifies the time at which the JWT was issued. It is represented as a unix timestamp.nbf (Not before): Identifies the time at which the JWT will start to be accepted for processing. It is represented as a unix timestamp. By default it is set to be 1 ms before iat.typ (Token Type): The type of the token. By default it is &quot;access&quot;. Note that this is not the same as the typ entry in the JWT's header, which will always be &quot;JWT&quot;.jti (JWT ID): The unique id of the token.You can add custom claims additionally when calling the function Guardian.encode_and_sign.For further information, refer to the module Guardian.Token.Jwt.","ref":"tokens-jwt-start.html","title":"Start","type":"extras"},{"doc":"Not yet implementedIf you'd like to help with this guide please submit a pull request to Guardian in the guides/plug/start-plug.md file.","ref":"plug-start.html","title":"Start","type":"extras"},{"doc":"PipelinesGuardian's Plug support provides an easy and composable way to put together your authentication.Different parts of your application are going to need different parts of the authentication system. For some areas, a user can be logged in, or not. For others users are required.Guardian's composable nature, coupled with the composable nature of Plug provide nearly endless options for customization. For that reason, this documentation will focus on walking through how Guardian pipelines work so you can get just the right solution for you.","ref":"plug-pipelines.html","title":"Pipelines","type":"extras"},{"doc":"A pipeline provides two main pieces.Access to your implementation moduleAn error handler for when folks aren't authenticatedThe pipeline puts these two modules into the Plug.Conn struct so that they're available to all downstream plugs. This means that we can set these at the start of our plug chain and even swap them out downstream if we need to. More on that later, though.","ref":"plug-pipelines.html#what-is-a-guardian-pipeline","title":"Pipelines - What is a Guardian Pipeline?","type":"extras"},{"doc":"When we use Guardian.Plug.Pipeline, it's just wrapping up a bunch of plugs for us into a nice neat bundle. In order to understand what it's doing, we'll first look at it manually.The first step is to use the pipeline plug to specify the implementation module and error handler.plug Guardian.Plug.Pipeline, module: AuthMe.UserManager.Guardian, error_handler: AuthMe.UserManager.ErrorHandlers.JSONThis injects the module and error handler into the conn struct and makes them available to downstream plugs.The next thing that we're going to want to do is find the token. Guardian provides plugs to find and validate tokens from a number of sources.VerifySession - For when the token is stored in the sessionVerifyHeader - Authorization header token locationVerifyCookie (deprecated) - A cookie has the token stored# ... # plug Guardian.Plug.Pipeline (from above) # Look for a token in the session. # If there is no session or no token nothing happens and control is passed to the next plug # If a token is found it&#39;s verified and added to the conn struct available with `Guardian.Plug.current_token` and `Guardian.Plug.current_claims` plug Guardian.Plug.VerifySession, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} # Look for a token in the HTTP Authorization header. (prefixed with `&quot;Bearer &quot;`) plug Guardian.Plug.VerifyHeader, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;}These two plugs will look for tokens in the given locations and also restrict them to only validate for tokens that have the claim typ == &quot;access&quot;. You don't need to restrict to a type or you could add other literal claims to verify.So far in our manual pipeline we've not actually enforced someone is logged in or if they are, we haven't loaded the resource associated with the token. Lets add that next.# return unauthenticated via the error handler if there is no validated token found previously plug Guardian.Plug.EnsureAuthenticated # if there is a verified token, load the user using the implementation module plug Guardian.Plug.LoadResourceThat's effectively our entire pipeline. Putting it all together in a Phoenix router:pipeline :auth do plug Guardian.Plug.Pipeline, module: AuthMe.UserManager.Guardian, error_handler: AuthMe.UserManager.ErrorHandlers.JSON plug Guardian.Plug.VerifySession, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.VerifyHeader, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.EnsureAuthenticated plug Guardian.Plug.LoadResource end scope &quot;/&quot;, AuthMeWeb do pipe_through [:auth] end","ref":"plug-pipelines.html#a-manual-version","title":"Pipelines - A manual version","type":"extras"},{"doc":"You can take the above setup and wrap it up in a plug all of it's own.defmodule AuthMe.UserManager.Pipeline do use Guardian.Plug.Pipeline, otp_app: :auth_me, module: AuthMe.UserManager.Guardian, error_handler: AuthMe.UserManager.ErrorHandlers.JSON plug Guardian.Plug.VerifySession, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.VerifyHeader, claims: %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.EnsureAuthenticated plug Guardian.Plug.LoadResource endThis is a plug that you can use anywhere you'd normally use a plug.# phoenix router pipeline :auth do plug AuthMe.UserManager.Pipeline end scope &quot;/&quot;, AuthMe do pipe_through [:auth] end","ref":"plug-pipelines.html#module-version","title":"Pipelines - Module version","type":"extras"},{"doc":"Sometimes we need to change out the error handler. For example maybe in one area there's a module that redirects for customers, one for admins, maybe there's one that renders a page and maybe one that does JSON responses. That's a lot of behaviour to try to wrap into a single pipeline module. It's for this reason that you can change your error handler (and even your module) anytime by using the Guardian.Plug.Pipeline plug. Just specify which error handler to use downstream and you're good to go. As an example using a Phoenix router: pipeline :auth do plug AuthMe.UserManager.Pipeline end pipeline :auth_html_errors do plug Guardian.Plug.Pipeline, error_handler: AuthMe.UserManager.ErrorHandlers.HTML end pipeline :auth_json_errors do plug Guardian.Plug.Pipeline, error_handler: AuthMe.UserManager.ErrorHandlers.JSON end scope &quot;/api&quot; do pipe_through [:auth, :auth_json_errors] # ... end scope &quot;/www&quot; do pipe_through [:auth, :auth_html_errors] # ... endWe don't have to just handle these in the router though. In Phoenix we can also use the controller.defmodule AuthMeWeb.SnowflakeController do use AuthMeWeb, :controller plug Guardian.Plug.Pipeline, error_handler: __MODULE__ # ... @behaviour Guardian.Plug.ErrorHandler @impl Guardian.Plug.ErrorHandler def auth_error(conn, {type, reason}, opts) do # handle with a redirect or render end end","ref":"plug-pipelines.html#changing-the-error-handler","title":"Pipelines - Changing the error handler","type":"extras"},{"doc":"The plugs for Guardian are very composable, as is Plug itself and Phoenix routes.It's a good idea to have at least two Phoenix pipelines for authentication.Find and verify the token if it's providedEnsure authenticated where appropriateThe Guardian.Plug.VerifySession will work fine if sessions are loaded and if they're not it will just move on to the next plug so we can always just check both.In this example we'll show it without the Pipeline module. Using the pipeline module can tidy things up for you and make it reusable if you're not using Phoenix.pipeline :maybe_auth do plug Guardian.Plug.Pipeline, module: AuthMe.UserManager.Guardian, error_handler: AuthMe.UserManager.ErrorHandlers.JSON plug Guardian.Plug.VerifySession, %{&quot;typ&quot; =&gt; &quot;access&quot;} plug Guardian.Plug.VerifyHeader, %{&quot;typ&quot; =&gt; &quot;access&quot;} # if there isn&#39;t anyone logged in we don&#39;t want to return an error. Use allow_blank plug Guardian.Plug.LoadResource, allow_blank: true end pipeline :ensure_auth do plug Guardian.Plug.EnsureAuthenticated endUsing these two pipelines should give you plenty of mileage in your router. Remember that the pipeline applies downstream so you can change out the module or error handler anywhere downstream including your controllers.","ref":"plug-pipelines.html#good-practices","title":"Pipelines - Good practices","type":"extras"},{"doc":"Not yet implementedIf you'd like to help with this guide please submit a pull request to Guardian in the guides/phoenix/start-phoenix.md file.","ref":"phoenix-start.html","title":"Start","type":"extras"},{"doc":"Not yet implementedIf you'd like to help with this guide please submit a pull request to Guardian in the guides/permissions/start-permissions.md file.","ref":"permissions-start.html","title":"Start","type":"extras"},{"doc":"Upgrade guide 0.14.x to 1.0The move from 0.14.x to 1.0 is significant behind the scenes. Although we've tried to keep backwards compatibility where we could, in order to move Guardian forward we've had to make some breaking changes. Guardian is no longer constrained to using only JWT. Although it provides all the JWT behaviour out of the box that it used to, you can now add your own types of tokens.Dependencies on Phoenix and Plug have been made optional so that Guardian can be used in a more stand-alone manner.","ref":"upgrading-v1.0.html","title":"Upgrade guide 0.14.x to 1.0","type":"extras"},{"doc":"In 0.14.x Guardian was a single, globally unique implementation. In 1.0 you'll need to define a module where all your authentication related items live. You'll also interact with this module rather than directly with Guardian (unless you're a library developer).The Implementation module is the serializer and provides a place for you to put Hooks. To create the implementation:defmodule MyApp.Guardian do use Guardian, otp_app: :my_app # ... end","ref":"upgrading-v1.0.html#implementation","title":"Upgrade guide 0.14.x to 1.0 - Implementation","type":"extras"},{"doc":"Configuration has not changed a lot, but the way that you can define config values has become a lot more useful.Configuration values can be given using the following types:{MyModule, :func, [:some, :args]} Calls the function on the module with argsany other valueThe old values (assuming you're using JWT) are still present, but there are a few new options.token_verify_module - The module to verify claims. Default Guardian.Token.Jwt.Verifytoken_ttl - A map of %{&lt;token_type&gt; =&gt; &lt;ttl_value&gt;}Rather than setting configuration for Guardian directly, use your implementation module.0.14.xconfig :guardian, Guardian, # options1.0config :my_app, MyApp.Guardian, # optionsSerializersIn 0.14.x you defined a serializer. The two functions from_token, and for_token have been renamed and moved. In 0.14.x you'd create a serializer with these two functions.The new functions are subject_for_token and resource_from_claims. These functions are more clearly named and receive more complete arguments.defmodule MyApp.Guardian do use Guardian, otp_app: :my_app def subject_for_token(resource, _claims) do {:ok, to_string(resource.id)} end def subject_for_token(_, _) do {:error, :reason_for_error} end def resource_from_claims(claims) do {:ok, find_me_a_resource(claims[&quot;sub&quot;])} end def resource_from_claims(_claims) do {:error, :reason_for_error} end endThe options for the use call require an :otp_app specification. You can also include your configuration that does not change across environments here if you choose.Creating tokensWas:Guardian.encode_and_sign(resource, [token_type, claims]) Guardian.decode_and_verify(token, [claims_to_check])Becomes:MyApp.Guardian.encode_and_sign(resource, [claims, options]) MyApp.Guardian.decode_and_verify(token, [claims_to_check, options])Where options are specified in the Guardian.Token.Jwt moduleToken types0.14.xGuardian.encode_and_sign(resource, &quot;other_type&quot;)1.0MyApp.Guardian.encode_and_sign(resource, %{}, token_type: &quot;other_type&quot;)Setting TTL0.14.xGuardian.encode_and_sign(resource, %{ttl: {1, :hour}})1.0MyApp.Guardian.encode_and_sign(resource, %{}, token_ttl: {1, :hour})Custom Secrets0.14.xGuardian.encode_and_sign(resource, %{secret: &quot;some_secret&quot;})1.0MyApp.Guardian.encode_and_sign(resource, %{}, secret: resolvable_config_value)Exchange0.14.x {:ok, new_token, new_claims} = Guardian.exchange(old_token, &quot;refresh&quot;, &quot;access&quot;)1.0 {:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Guardian.exchange(old_token, [&quot;refresh&quot;], &quot;access&quot;)Refresh0.14.x {:ok, new_token, new_claims} = Guardian.refresh!(old_token, claims_to_check, options)1.0 {:ok, {old_token, old_claims}, {new_token, new_claims}} = MyApp.Guardian.refresh(old_token, opts)Revoke0.14.x :ok = Guardian.revoke!(token, claims, opts)1.0 {:ok, old_claims} = MyApp.Guardian.revoke(old_token, opts)","ref":"upgrading-v1.0.html#configuration","title":"Upgrade guide 0.14.x to 1.0 - Configuration","type":"extras"},{"doc":"When working with plugs, sign_in/sign_out are still with us but instead of using the Guardian Module directly use your own implementation0.14.xconn = Guardian.Plug.sign_in(conn, resource, [token_type, claims]) conn = Guardian.Plug.sign_out(conn, token, [claims_to_check])1.0conn = MyApp.Guardian.Plug.sign_in(conn, resource, [claims, opts]) conn = MyApp.Guardian.Plug.sign_out(conn, resource, [claims_to_check, opts])","ref":"upgrading-v1.0.html#sign-in-sign-out","title":"Upgrade guide 0.14.x to 1.0 - Sign In/Sign Out","type":"extras"},{"doc":"To use Guardian with Plugs you'll now need to define a pipeline. A pipeline is a plug thatSets the implementation module to useSets the error handler to useAdds the plug pipeline to usedefmodule MyApp.Guardian.AuthPipeline do @claims %{typ: &quot;access&quot;} use Guardian.Plug.Pipeline, otp_app: :my_app, module: MyApp.Guardian, error_handler: MyApp.Guardian.AuthErrorHandler plug Guardian.Plug.VerifySession, claims: @claims plug Guardian.Plug.VerifyHeader, claims: @claims, realm: &quot;Bearer&quot; plug Guardian.Plug.EnsureAuthenticated plug Guardian.Plug.LoadResource, allow_blank: false endUse this as a plug to:Lookup the token in either the session or headerVerify the token, it must be of type &quot;access&quot;Ensure we found a tokenLoad the resource for the token and make sure one was foundYou'd use this in your Phoenix router.Error handlerThe error handler modules have had a makeover. Previously when you used one of Guardian's plugs you would specify a module with a number of callbacks0.14.xalready_authenticated(Plug.Conn.t, map) :: Plug.Conn.tunauthenticated(Plug.Conn.t, map) :: Plug.Conn.tunauthorized(Plug.Conn.t, map) :: Plug.Conn.tno_resource(Plug.Conn.t, map) :: Plug.Conn.tIn 1.0 error handler modules have been simplified. There is now a single function requiredauth_error(conn, {failure_type, reason}, opts)The failure types that come out of the box are::invalid_token:unauthorized:unauthenticated:already_authenticated:no_resource_found","ref":"upgrading-v1.0.html#pipelines","title":"Upgrade guide 0.14.x to 1.0 - Pipelines","type":"extras"},{"doc":"0.14.x required any custom claims to be specified when you create the token either with sign_in or encode_and_verify. 1.0 still allows specifying literal claims inline but also provides a hook in your implementation module.defmodule MyApp.Guardian do use Guardian, otp_app: :my_app def build_claims(claims, resource, opts) do # opts is passed directly from the caller new_claims = do_things_to_claims(claims) {:ok, claims} end end","ref":"upgrading-v1.0.html#custom-claims","title":"Upgrade guide 0.14.x to 1.0 - Custom Claims","type":"extras"},{"doc":"The hooks module has been removed. Rather than this there are callbacks defined on your implementation. These are noops by default. See the Guardian module documentation for more information.after_encode_and_signafter_sign_inbefore_sign_outon_verifyon_revokeon_refreshon_exchangebuild_claims","ref":"upgrading-v1.0.html#hooks","title":"Upgrade guide 0.14.x to 1.0 - Hooks","type":"extras"},{"doc":"The macros that were provided for Phoenix sockets and channels have been removed. There is now only a lightweight set of functions to help store resource/claims/token on the socket.Guardian.Phoenix.Socket.authenticated? - check if the socket has been authenticatedGuardian.Phoenix.Socket.authenticate - Sign in a resource to a socket. Sets token/claims/resource on the socket.Guardian.Phoenix.Socket.current_claimsGuardian.Phoenix.Socket.current_tokenGuardian.Phoenix.Socket.current_resource0.14.xdefmodule MyApp.UserSocket do use Phoenix.Socket use Guardian.Phoenix.Socket ## Channels channel &quot;user:*&quot;, MyApp.UserChannel ## Transports transport :websocket, Phoenix.Transports.WebSocket # transport :longpoll, Phoenix.Transports.LongPoll def connect(_params, _socket) do :error end def id(socket), do: &quot;users_socket:\#{current_resource(socket).id}&quot; end1.0defmodule MyApp.UserSocket do use Phoenix.Socket ## Channels channel &quot;user:*&quot;, MyApp.UserChannel ## Transports transport :websocket, Phoenix.Transports.WebSocket # transport :longpoll, Phoenix.Transports.LongPoll def connect(%{&quot;guardian_token&quot; =&gt; token}, socket) do case Guardian.Phoenix.Socket.authenticate(socket, MyApp.Guardian, token) do {:ok, authed_socket} -&gt; {:ok, authed_socket} {:error, _} -&gt; :error end end def connect(_params, _socket) do :error end def id(socket), do: &quot;users_socket:\#{Guardian.Phoenix.Socket.current_resource(socket).id}&quot; end","ref":"upgrading-v1.0.html#sockets-channels","title":"Upgrade guide 0.14.x to 1.0 - Sockets/Channels","type":"extras"},{"doc":"Permissions are not always active anymore. These have become optional and renamed to be more clear.See Guardian.Permissions.Bitwise for more informationTo use permissions (Bitwise), in your implementation module use the bitwise module and then utilize the build_claims hook.Permissions can be defined as a list - using positional bits, or via a Map where the value is the bit location. defmodule MyApp.Guardian do use Guardian, otp_app: :my_app, permissions: %{ user_actions: %{ books: 0b1, fitness: 0b100, music: 0b1000, } } use Guardian.Permissions.Bitwise # snip def build_claims(claims, _resource, opts) do claims = claims |&gt; encode_permissions_into_claims!(Keyword.get(opts, :permissions)) {:ok, claims} end end endIn this case, when creating the token the options are passed to build claims as-is. So to call this it would look like.MyApp.Guardian.encode_and_sign(resource, %{}, permissions: %{user_actions: [:books, :fitness]})To interrogate permissions:# Get the encoded permissions from the claims found_perms = MyApp.Guardian.decode_permissions_from_claims(claims) # Check if all permissions are present has_all_these_things? = claims |&gt; MyApp.Guardian.decode_permissions_from_claims(claims) |&gt; MyApp.Guardian.all_permissions?(%{user_actions: [:books]}) # Checks if any permissions are present show_any_media_things? = claims |&gt; MyApp.Guardian.decode_permissions_from_claims(claims) |&gt; MyApp.Guardian.any_permissions?(%{user_actions: [:books, :fitness, :music]})Usage with PlugThe Guardian.Plug.EnsurePermissions Plug has been removed. Instead use the Guardian.Plug.Bitwise module. This must be used downstream of a Guardian Pipeline plug Guardian.Permissions.Bitwise, ensure: %{user_actions: [:books]}A one_of feature is supported where you can give a list of possible permission configurations. If one of them matches, the permission will be considered granted.Allow the request to continue when the token contains any of the permission sets specifiedplug Guardian.Permissions.Bitwise, one_of: [ %{default: [:public_profile], user_actions: [:books]}, %{default: [:public_profile], user_actions: [:music]}, ]","ref":"upgrading-v1.0.html#permissions","title":"Upgrade guide 0.14.x to 1.0 - Permissions","type":"extras"}]