sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"},{"anchor":"mix-tasks","id":"Mix Tasks"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"documentation","id":"Documentation"},{"anchor":"installation","id":"Installation"},{"anchor":"basics","id":"Basics"},{"anchor":"configuration","id":"Configuration"},{"anchor":"secrets-jwt","id":"Secrets (JWT)"},{"anchor":"using-options-in-calls","id":"Using options in calls"},{"anchor":"hooks","id":"Hooks"},{"anchor":"plugs","id":"Plugs"},{"anchor":"permissions","id":"Permissions"},{"anchor":"tracking-tokens","id":"Tracking Tokens"},{"anchor":"best-testing-practices","id":"Best testing practices"},{"anchor":"related-projects","id":"Related projects"},{"anchor":"more-advanced-secrets","id":"More advanced secrets"},{"anchor":"copyright-and-license","id":"Copyright and License"}],"id":"readme","title":"Readme"},{"group":"Introduction","headers":[{"anchor":"defaults","id":"Defaults"},{"anchor":"guardian","id":"Guardian"},{"anchor":"tokens-in-your-application","id":"Tokens in your application"},{"anchor":"guides","id":"Guides"}],"id":"introduction-overview","title":"Overview"},{"group":"Introduction","headers":[{"anchor":"implementation-module","id":"Implementation Module"},{"anchor":"configuration","id":"Configuration"},{"anchor":"plug-phoenix-and-guardian","id":"Plug, Phoenix, and Guardian"}],"id":"introduction-installation","title":"Installation"},{"group":"Introduction","headers":[{"anchor":"usage","id":"Usage"},{"anchor":"basic-setup","id":"Basic Setup"},{"anchor":"configuration","id":"Configuration"},{"anchor":"callbacks","id":"Callbacks"}],"id":"introduction-implementation","title":"Implementation Modules"},{"group":"Introduction","headers":[{"anchor":"chat","id":"Chat"},{"anchor":"forum","id":"Forum"}],"id":"introduction-community","title":"Community"},{"group":"Tutorial","headers":[{"anchor":"specify-your-dependencies","id":"Specify your dependencies"},{"anchor":"create-a-user-manager","id":"Create a user manager"},{"anchor":"create-implementation-module","id":"Create implementation module"},{"anchor":"setup-guardian-config","id":"Setup Guardian config"},{"anchor":"password-hashing","id":"Password hashing"},{"anchor":"pipelines","id":"Pipelines"},{"anchor":"controller","id":"Controller"},{"anchor":"routes","id":"Routes"},{"anchor":"try-it-out","id":"Try it out"}],"id":"tutorial-start","title":"Getting Started with Guardian"},{"group":"Tokens","headers":[],"id":"tokens-start","title":"Start"},{"group":"JWT Tokens","headers":[],"id":"tokens-jwt-start","title":"Start"},{"group":"Plug","headers":[],"id":"plug-start","title":"Start"},{"group":"Plug","headers":[{"anchor":"what-is-a-guardian-pipeline","id":"What is a Guardian Pipeline?"},{"anchor":"a-manual-version","id":"A manual version"},{"anchor":"module-version","id":"Module version"},{"anchor":"changing-the-error-handler","id":"Changing the error handler"},{"anchor":"good-practices","id":"Good practices"}],"id":"plug-pipelines","title":"Pipelines"},{"group":"Phoenix","headers":[],"id":"phoenix-start","title":"Start"},{"group":"Permissions","headers":[],"id":"permissions-start","title":"Start"},{"group":"Upgrade Guides","headers":[{"anchor":"implementation","id":"Implementation"},{"anchor":"configuration","id":"Configuration"},{"anchor":"sign-in-sign-out","id":"Sign In/Sign Out"},{"anchor":"pipelines","id":"Pipelines"},{"anchor":"custom-claims","id":"Custom Claims"},{"anchor":"hooks","id":"Hooks"},{"anchor":"sockets-channels","id":"Sockets/Channels"},{"anchor":"permissions","id":"Permissions"}],"id":"upgrading-v1.0","title":"Upgrade guide 0.14.x to 1.0"}],"modules":[{"group":"","id":"Guardian","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:conditional_tuple/0","id":"conditional_tuple/0"},{"anchor":"t:options/0","id":"options/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"decode_and_verify/4","id":"decode_and_verify/4"},{"anchor":"encode_and_sign/4","id":"encode_and_sign/4"},{"anchor":"exchange/5","id":"exchange/5"},{"anchor":"peek/2","id":"peek/2"},{"anchor":"refresh/3","id":"refresh/3"},{"anchor":"resource_from_token/4","id":"resource_from_token/4"},{"anchor":"revoke/3","id":"revoke/3"},{"anchor":"stringify_keys/1","id":"stringify_keys/1"},{"anchor":"timestamp/0","id":"timestamp/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:after_encode_and_sign/4","id":"after_encode_and_sign/4"},{"anchor":"c:after_sign_in/5","id":"after_sign_in/5"},{"anchor":"c:before_sign_out/3","id":"before_sign_out/3"},{"anchor":"c:build_claims/3","id":"build_claims/3"},{"anchor":"c:on_exchange/3","id":"on_exchange/3"},{"anchor":"c:on_refresh/3","id":"on_refresh/3"},{"anchor":"c:on_revoke/3","id":"on_revoke/3"},{"anchor":"c:on_verify/3","id":"on_verify/3"},{"anchor":"c:resource_from_claims/1","id":"resource_from_claims/1"},{"anchor":"c:subject_for_token/2","id":"subject_for_token/2"},{"anchor":"c:verify_claims/2","id":"verify_claims/2"}]}],"sections":[{"anchor":"module-generated-functions","id":"Generated functions"}],"title":"Guardian"},{"group":"","id":"Guardian.Config","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:config_value/0","id":"config_value/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"resolve_value/1","id":"resolve_value/1"}]}],"sections":[],"title":"Guardian.Config"},{"group":"","id":"Guardian.Plug.ErrorHandler","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:auth_error/3","id":"auth_error/3"}]}],"sections":[],"title":"Guardian.Plug.ErrorHandler"},{"group":"","id":"Guardian.Token.Jwt.SecretFetcher","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:fetch_signing_secret/2","id":"fetch_signing_secret/2"},{"anchor":"c:fetch_verifying_secret/3","id":"fetch_verifying_secret/3"}]}],"sections":[],"title":"Guardian.Token.Jwt.SecretFetcher"},{"group":"Tokens","id":"Guardian.Token","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:claims/0","id":"claims/0"},{"anchor":"t:decoding_error/0","id":"decoding_error/0"},{"anchor":"t:encoding_error/0","id":"encoding_error/0"},{"anchor":"t:resource/0","id":"resource/0"},{"anchor":"t:secret_error/0","id":"secret_error/0"},{"anchor":"t:signing_error/0","id":"signing_error/0"},{"anchor":"t:token/0","id":"token/0"},{"anchor":"t:ttl/0","id":"ttl/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:build_claims/5","id":"build_claims/5"},{"anchor":"c:create_token/3","id":"create_token/3"},{"anchor":"c:decode_token/3","id":"decode_token/3"},{"anchor":"c:exchange/5","id":"exchange/5"},{"anchor":"c:peek/2","id":"peek/2"},{"anchor":"c:refresh/3","id":"refresh/3"},{"anchor":"c:revoke/4","id":"revoke/4"},{"anchor":"c:token_id/0","id":"token_id/0"},{"anchor":"c:verify_claims/3","id":"verify_claims/3"}]}],"sections":[],"title":"Guardian.Token"},{"group":"Tokens","id":"Guardian.Token.Jwt","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"build_claims/5","id":"build_claims/5"},{"anchor":"create_token/3","id":"create_token/3"},{"anchor":"decode_token/3","id":"decode_token/3"},{"anchor":"exchange/5","id":"exchange/5"},{"anchor":"peek/2","id":"peek/2"},{"anchor":"refresh/3","id":"refresh/3"},{"anchor":"revoke/4","id":"revoke/4"},{"anchor":"token_id/0","id":"token_id/0"},{"anchor":"verify_claims/3","id":"verify_claims/3"}]}],"sections":[],"title":"Guardian.Token.Jwt"},{"group":"Tokens","id":"Guardian.Token.Jwt.Verify","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"verify_claims/3","id":"verify_claims/3"}]}],"sections":[],"title":"Guardian.Token.Jwt.Verify"},{"group":"Tokens","id":"Guardian.Token.Verify","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"time_within_drift?/2","id":"time_within_drift?/2"},{"anchor":"verify_literal_claims/3","id":"verify_literal_claims/3"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:verify_claim/4","id":"verify_claim/4"}]}],"sections":[],"title":"Guardian.Token.Verify"},{"group":"Plugs","id":"Guardian.Plug","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"authenticated?/2","id":"authenticated?/2"},{"anchor":"clear_remember_me/3","id":"clear_remember_me/3"},{"anchor":"current_claims/2","id":"current_claims/2"},{"anchor":"current_resource/2","id":"current_resource/2"},{"anchor":"current_token/2","id":"current_token/2"},{"anchor":"default_key/0","id":"default_key/0"},{"anchor":"find_token_from_cookies/2","id":"find_token_from_cookies/2"},{"anchor":"maybe_halt/2","id":"maybe_halt/2"},{"anchor":"put_current_claims/3","id":"put_current_claims/3"},{"anchor":"put_current_resource/3","id":"put_current_resource/3"},{"anchor":"put_current_token/3","id":"put_current_token/3"},{"anchor":"put_session_token/3","id":"put_session_token/3"},{"anchor":"remember_me/5","id":"remember_me/5"},{"anchor":"remember_me_from_token/5","id":"remember_me_from_token/5"},{"anchor":"session_active?/1","id":"session_active?/1"},{"anchor":"sign_in/5","id":"sign_in/5"},{"anchor":"sign_out/3","id":"sign_out/3"}]}],"sections":[],"title":"Guardian.Plug"},{"group":"Plugs","id":"Guardian.Plug.EnsureAuthenticated","sections":[{"anchor":"module-example","id":"Example"}],"title":"Guardian.Plug.EnsureAuthenticated"},{"group":"Plugs","id":"Guardian.Plug.EnsureNotAuthenticated","sections":[{"anchor":"module-example","id":"Example"}],"title":"Guardian.Plug.EnsureNotAuthenticated"},{"group":"Plugs","id":"Guardian.Plug.Keys","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"key_from_other/1","id":"key_from_other/1"}]}],"sections":[],"title":"Guardian.Plug.Keys"},{"group":"Plugs","id":"Guardian.Plug.LoadResource","sections":[{"anchor":"module-example","id":"Example"}],"title":"Guardian.Plug.LoadResource"},{"group":"Plugs","id":"Guardian.Plug.Pipeline","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"__using__/1","id":"__using__/1"},{"anchor":"current_error_handler/1","id":"current_error_handler/1"},{"anchor":"current_key/1","id":"current_key/1"},{"anchor":"current_module/1","id":"current_module/1"},{"anchor":"fetch_error_handler/2","id":"fetch_error_handler/2"},{"anchor":"fetch_error_handler!/2","id":"fetch_error_handler!/2"},{"anchor":"fetch_key/2","id":"fetch_key/2"},{"anchor":"fetch_module/2","id":"fetch_module/2"},{"anchor":"fetch_module!/2","id":"fetch_module!/2"},{"anchor":"put_error_handler/2","id":"put_error_handler/2"},{"anchor":"put_key/2","id":"put_key/2"},{"anchor":"put_module/2","id":"put_module/2"}]}],"sections":[],"title":"Guardian.Plug.Pipeline"},{"group":"Plugs","id":"Guardian.Plug.SlidingCookie","sections":[],"title":"Guardian.Plug.SlidingCookie"},{"group":"Plugs","id":"Guardian.Plug.VerifyCookie","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"refresh_from_cookie/2","id":"refresh_from_cookie/2"}]}],"sections":[],"title":"Guardian.Plug.VerifyCookie"},{"group":"Plugs","id":"Guardian.Plug.VerifyHeader","sections":[],"title":"Guardian.Plug.VerifyHeader"},{"group":"Plugs","id":"Guardian.Plug.VerifySession","sections":[],"title":"Guardian.Plug.VerifySession"},{"group":"Permissions","id":"Guardian.Permissions","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:input_label/0","id":"input_label/0"},{"anchor":"t:input_permissions/0","id":"input_permissions/0"},{"anchor":"t:input_set/0","id":"input_set/0"},{"anchor":"t:label/0","id":"label/0"},{"anchor":"t:permission/0","id":"permission/0"},{"anchor":"t:permission_label/0","id":"permission_label/0"},{"anchor":"t:permission_set/0","id":"permission_set/0"},{"anchor":"t:plug_option/0","id":"plug_option/0"},{"anchor":"t:t/0","id":"t/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"call/2","id":"call/2"},{"anchor":"init/1","id":"init/1"},{"anchor":"max/0","id":"max/0"}]}],"sections":[],"title":"Guardian.Permissions"},{"group":"Permissions","id":"Guardian.Permissions.AtomEncoding","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decode/3","id":"decode/3"},{"anchor":"encode/3","id":"encode/3"}]}],"sections":[],"title":"Guardian.Permissions.AtomEncoding"},{"group":"Permissions","id":"Guardian.Permissions.BitwiseEncoding","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decode/3","id":"decode/3"},{"anchor":"encode/3","id":"encode/3"}]}],"sections":[],"title":"Guardian.Permissions.BitwiseEncoding"},{"group":"Permissions","id":"Guardian.Permissions.PermissionEncoding","nodeGroups":[{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:decode/3","id":"decode/3"},{"anchor":"c:encode/3","id":"encode/3"}]}],"sections":[],"title":"Guardian.Permissions.PermissionEncoding"},{"group":"Permissions","id":"Guardian.Permissions.TextEncoding","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decode/3","id":"decode/3"},{"anchor":"encode/3","id":"encode/3"}]}],"sections":[],"title":"Guardian.Permissions.TextEncoding"},{"group":"Exceptions","id":"Guardian.MalformedReturnValueError","sections":[],"title":"Guardian.MalformedReturnValueError"},{"group":"Exceptions","id":"Guardian.Permissions.PermissionNotFoundError","sections":[],"title":"Guardian.Permissions.PermissionNotFoundError"},{"group":"Exceptions","id":"Guardian.Plug.UnauthenticatedError","sections":[],"title":"Guardian.Plug.UnauthenticatedError"}],"tasks":[{"group":"","id":"Mix.Tasks.Guardian.Gen.Secret","sections":[],"title":"mix guardian.gen.secret"}]}